/*
    =========================================================================
	File:		GetPropsTest.java
	Author:		Warren Pfeffer
	Contact:	slinky@njcc.com
    =========================================================================
    Copyright (C) 1997  Warren Pfeffer

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program (see COPYING-2.0.gz); if not, write to:

		Free Software Foundation, Inc.
		59 Temple Place, Suite 330
		Boston, MA  02111-1307  USA
    =========================================================================
*/
package WARREN.test;

/*
	Here is a test driver for the GetProps class.
	If the following command is executed;

	java -Ddbug -DGetPropsTestB_file_name="/tmp/foo" WARREN.test.GetPropsTest

	the results are:

	GetPropsTestA$AProps.dbug=true
	GetPropsTestA$AProps.file_name=
	GetPropsTestB$BProps.dbug=true
	GetPropsTestB$BProps.file_name=/tmp/foo
	GetPropsTestA$AProps.dbug=true
	GetPropsTestA$AProps.file_name=/tmp/boo
	GetPropsTestB$BProps.dbug=false
	GetPropsTestB$BProps.file_name=/tmp/foo
*/

import WARREN.tools.GetProps;

class GetPropsTestA {
	public static class Props extends GetProps {
		public boolean dbug;
		public String file_name;
	}
	static Props p = new Props();

	public void PrintProps()
		{p.List(System.err);}
}

class GetPropsTestB {
	public static class Props extends GetProps {
		public boolean dbug;
		public String file_name;
	}
	static Props p = new Props();

	public void PrintProps()
		{p.List(System.err);}
}

class GetPropsTest {

	static public void main(String args[])
	{
		GetPropsTestA a = new GetPropsTestA();
		GetPropsTestB b = new GetPropsTestB();

		a.PrintProps();
		b.PrintProps();

		a.p.file_name = "/tmp/boo";
		b.p.dbug = false;

		a.PrintProps();
		b.PrintProps();
	}
}
