/*
    =========================================================================
	File:		HashableZipFile.java
	Author:		Warren Pfeffer
	Contact:	slinky@njcc.com
    =========================================================================
    Copyright (C) 1997  Warren Pfeffer

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program (see COPYING-2.0.gz); if not, write to:

		Free Software Foundation, Inc.
		59 Temple Place, Suite 330
		Boston, MA  02111-1307  USA
    =========================================================================
*/
package WARREN.tools;

import java.io.*;
import java.util.*;
import java.util.zip.*;

//------------------------------------------

class HashableZipFile extends ZipFile {

	private String    dir_;

	public HashableZipFile(File file)
		throws ZipException, IOException
			{super(file);SetDir(getName());}

	public HashableZipFile(String name)
		throws IOException
			{super(name);SetDir(getName());}

	public String Dir()
		{return dir_;}

	public int hashCode()
		{return getName().hashCode();}

	public String toString()
		{return getName();}

	private void SetDir(String path)
	{
		int		zip_idx;
		String	file_sep = System.getProperty("file.separator");

		if(
			(zip_idx = path.lastIndexOf(".zip")) >= 0
			||
			(zip_idx = path.lastIndexOf(".jar")) >= 0
			)
		{
			  dir_ = path.substring(0, zip_idx)+file_sep;
		}
		else
		{
			  dir_ = "."+file_sep;
		}
	}
}
//------------------------------------------
