/*
    =========================================================================
	File:		Pkg.java
	Author:		Warren Pfeffer
	Contact:	slinky@njcc.com
    =========================================================================
    Copyright (C) 1997  Warren Pfeffer

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program (see COPYING-2.0.gz); if not, write to:

		Free Software Foundation, Inc.
		59 Temple Place, Suite 330
		Boston, MA  02111-1307  USA
    =========================================================================
*/

package WARREN.tools;

import java.util.Enumeration;
import java.util.Vector;

//--------------------------------------------------------------

class Pkg extends SrcSymbol {

	private static final String file_sep_ =
		System.getProperty("file.separator");
	private String	pkg_sub_pth_;
	private	Vector	pkg_locs_;	// collection of PkgLocs

	final String Name()
		{return SymbolName();}

	final String SubPth()
		{return pkg_sub_pth_;}

	final void AddPkgLoc(Object cls_pth_ent)
	{
		pkg_locs_.addElement(new PkgLoc(this, cls_pth_ent));
	}

	final Enumeration PkgLocIterator()
	{
		return pkg_locs_.elements();
	}

	final PkgLoc LastPkgLoc()
	{
		return (PkgLoc)pkg_locs_.lastElement();
	}

	Pkg(String pkg_name, String file_name, int lno)
	{
		super(pkg_name, file_name, lno);

		pkg_sub_pth_ =
			pkg_name
			.replace('.', file_sep_.charAt(0))
			.concat(file_sep_)
			;

		pkg_locs_ = new Vector();
	}
}
