/*
    =========================================================================
	File:		PkgLoc.java
	Author:		Warren Pfeffer
	Contact:	slinky@njcc.com
    =========================================================================
    Copyright (C) 1997  Warren Pfeffer

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program (see COPYING-2.0.gz); if not, write to:

		Free Software Foundation, Inc.
		59 Temple Place, Suite 330
		Boston, MA  02111-1307  USA
    =========================================================================
*/

package WARREN.tools;

import java.io.File;

//--------------------------------------------------------------

class PkgLoc extends JDSystem {

	public static class Props extends GetProps {
		public boolean nozip;   // show zip contents as the dependency
		public boolean zres;
	}
	private static Props $ = new Props();

	private Pkg		pkg_;			// parent
	private Object	cls_pth_ent_;	// ZippedDir or File object
	private String	pkg_full_pth_;
	private String	pkg_arch_pth_;

	final String FullPth()
		{return pkg_full_pth_;}

	final String ArchPth()
		{return pkg_arch_pth_;}

	final boolean IsZippedDirEnt()
		{return (cls_pth_ent_ instanceof ZippedDir);}

	final boolean IsFileDirEnt()
		{return (cls_pth_ent_ instanceof File);}

	final ZippedDir ZippedDirEnt()
		{return (ZippedDir)cls_pth_ent_;}

	final File FileDirEnt()
		{return (File)cls_pth_ent_;}

	final Pkg GetPkg()
		{return pkg_;}

	PkgLoc(Pkg pkg, Object cls_pth_ent)
	{
		pkg_ = pkg;
		cls_pth_ent_ = cls_pth_ent;

		if(IsFileDirEnt())
		{
			pkg_full_pth_ = FileDirEnt().getPath();
			pkg_arch_pth_ = pkg_full_pth_;
		}
		else
		{
			pkg_full_pth_ = ZippedDirEnt().ArchiveDirPth()
							+ pkg_.SubPth();

			pkg_arch_pth_ = ZippedDirEnt().ArchiveFullPth();

			if($.nozip)
			{
				pkg_arch_pth_ = pkg_full_pth_;
			}
			else
			{
				/*
				if($.zres)
				{
					PrintMakeln("# "+pkg_full_pth_);
				}
				*/
			}
		}
	}
}
