/*
    =========================================================================
	File:		SequencedSet.java
	Author:		Warren Pfeffer
	Contact:	slinky@njcc.com
    =========================================================================
    Copyright (C) 1997  Warren Pfeffer

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program (see COPYING-2.0.gz); if not, write to:

		Free Software Foundation, Inc.
		59 Temple Place, Suite 330
		Boston, MA  02111-1307  USA
    =========================================================================
*/
package WARREN.tools;

import COM.objectspace.jgl.HashSet;
import java.util.Enumeration;
import java.util.Vector;

public class SequencedSet implements Cloneable {

	private	HashSet	h_;
	private	Vector	v_;
	private HashSet r_;

	public SequencedSet()
	{
		h_ = new HashSet();
		v_ = new Vector();
		r_ = new HashSet();
	}

	public final void Append(Object obj)
		{if(h_.add(obj) == null) v_.addElement(obj);}

	public final boolean Contains(Object obj)
		{return (h_.get(obj) == null ? false : true);}

	public final Object Get(Object obj)
		{return h_.get(obj);}

	public final Enumeration Iterator()
		{return v_.elements();}

	public final int Size()
		{return h_.size();}

	public String toString()
		{return v_.toString();}

	public final Object Remove(Object obj)
	{
		Object	rc = null;

		if((rc = Get(obj)) != null)
		{
			v_.removeElement(obj);
			h_.remove(obj);
		}

		return rc;
	}

	public final void Clear()
	{
		h_.clear();
		v_.removeAllElements();
	}

	public Object clone()
	{
		SequencedSet	seqset = new SequencedSet();

		for(
			Enumeration itr = Iterator();
			itr.hasMoreElements();
		   )
		{
			seqset.Append(itr.nextElement());
		}

		return seqset;
	}

	public final void Dump()
	{
		for(
			Enumeration itr = Iterator();
			itr.hasMoreElements();
		   )
		{
			System.err.println(itr.nextElement().toString());
		}
	}

	public SequencedSet Clone()
		{return (SequencedSet)clone();}
}
//------------------------------------------
