/*
    =========================================================================
	File:		SrcSymbol.java
	Author:		Warren Pfeffer
	Contact:	slinky@njcc.com
    =========================================================================
    Copyright (C) 1997  Warren Pfeffer

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program (see COPYING-2.0.gz); if not, write to:

		Free Software Foundation, Inc.
		59 Temple Place, Suite 330
		Boston, MA  02111-1307  USA
    =========================================================================
*/
package WARREN.tools;

public class SrcSymbol extends JDSystem {

	private String	name_;
	private String	file_name_;
	private int		lno_;

	public SrcSymbol(String name, String file_name, int lno)
	{
		SetSymbolName(name);
		SetFileName(file_name);
		SetLineNum(lno);
	}

	private SrcSymbol()
		{name_ = file_name_ = null;}

	protected final void SetSymbolName(String name)
		{name_ = name;}

	protected final void SetFileName(String file_name)
		{file_name_ = file_name;}

	protected final void SetLineNum(int lno)
		{lno_ = lno;}

	public final String SymbolName()
		{return name_;}

	public final String FileName()
		{return file_name_;}

	public final int LineNum()
		{return lno_;}

	public final String FileAndLine()
		{return (file_name_+", "+lno_);}

	public int hashCode()
		{return name_.hashCode();}

	public String toString()
		{return name_;}

	public boolean equals(Object obj)
		{return name_.equals(obj.toString());}

	public String Dump()
	{
		return (
			"symbol="+name_
			+", file="+file_name_
			+", lno="+lno_
			);
	}
}
