/*
    =========================================================================
	File:		StrBuf.java
	Author:		Warren Pfeffer
	Contact:	slinky@njcc.com
    =========================================================================
    Copyright (C) 1997  Warren Pfeffer

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program (see COPYING-2.0.gz); if not, write to:

		Free Software Foundation, Inc.
		59 Temple Place, Suite 330
		Boston, MA  02111-1307  USA
    =========================================================================
*/

package WARREN.tools;

import java.io.InputStream;
import java.io.IOException;

public class StrBuf {

	private StringBuffer	sb_;
	private byte[]			ba_;

	private void Init()
	{
		sb_ = new StringBuffer();
		ba_ = new byte[1024];
	}

	public StrBuf()
	{
		Init();
	}

	public StrBuf(String s)
	{
		Init();
		Assign(s);
	}

	public final StrBuf Append(String s)
	{
		sb_.append(s);
		return this;
	}

	public final StrBuf Assign(String s)
	{
		sb_.setLength(0);
		return Append(s);
	}

	public final StrBuf Append(InputStream ips)
		throws IOException
	{
		int	len;

		while((len=ips.read(ba_)) > 0)
		{
			Append(new String(ba_, 0, len));
		}

		return this;
	}

	public final StrBuf Assign(InputStream ips)
		throws IOException
	{
		sb_.setLength(0);
		return Append(ips);
	}

	public String toString()
		{return sb_.toString();}

	public final int Length()
		{return sb_.length();}
}
