/*
    =========================================================================
	File:		Var.java
	Author:		Warren Pfeffer
	Contact:	slinky@njcc.com
    =========================================================================
    Copyright (C) 1997  Warren Pfeffer

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program (see COPYING-2.0.gz); if not, write to:

		Free Software Foundation, Inc.
		59 Temple Place, Suite 330
		Boston, MA  02111-1307  USA
    =========================================================================
*/
package WARREN.tools;

public class Var extends SrcSymbol {

	private String	decl_cls_;

	public Var(String name, String decl_cls, String file_name, int lno)
	{
		super(name, file_name, lno);
		SetDeclCls(decl_cls);
	}

	public Var()
	{
		this("", "", "", 0);
	}

	public final void SetDeclCls(String decl_cls)
		{decl_cls_ = decl_cls;}

	public final String Name()
		{return SymbolName();}

	public final String DeclCls()
		{return decl_cls_;}

	public String Dump()
	{
		return (
			"var="+Name()
			+", decl_cls="+decl_cls_
			+", file="+FileName()
			+", lno="+LineNum()
			);
	}
}
