/* Generated By:JavaCC: Do not edit this line. JavaDepend.java */
//------------------------------------------

package WARREN.tools;

import java.io.InputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.FileNotFoundException;
import java.util.Properties;
import java.util.StringTokenizer;
import java.util.Enumeration;
import COM.objectspace.jgl.HashSet;

//------------------------------------------

public class JavaDepend extends JDSystem implements JavaDependConstants {

         static final Version version_ = new Version();

         public static class Props extends GetProps {
                 public boolean dbug;    // general debugging on or off
                 public boolean prof;    // turn profiling on or off
                 public boolean ver;             // display version info
                 public String  files;   // .java files to parse
         }
         private static Props $ = new Props();

         class InrDecl {
                 private String name_;
                 private String full_name_;

                 InrDecl(String name, String full_name)
                 {
                         name_ = name;
                         full_name_ = full_name;
                 }

                 public String Name()
                         {return name_;}

                 public String FullName()
                         {return full_name_;}

                 public String toString()
                         {return name_;}

                 public int hashCode()
                         {return name_.hashCode();}

                 public boolean equals(Object obj)
                         {return name_.equals(obj.toString());}
         }

         private boolean inited_;
         private InputStream     ips_;
         private DependencyGraph dg_;
         private Properties props_;
         private String          file_sep_;
         private String          pkg_;
         private SequencedSet import_set_;       // imports discovered
         private SequencedSet type_set_;                 // possible Types discovered
         private HashSet var_set_;                               // variables discovered
         private SequencedSet class_decls_;      // declared classes (targets) discovered 
         private String file_name_;                      // the current source file
         private HashSet inner_decls_;   // inner class names discovered 
         private String          class_name_;
         private String          class_depth_name_;
         private String          outermost_class_name_;
         private String xtnds_;
         private String impls_;
         private Tgt             tgt_;
         private int             lno_;
         private String          prev_anon_;
         private int             anon_cnt_;

         public static void main(String args[])
         {
                 // create parser with dummy input stream

                 JavaDepend parser = new JavaDepend(System.in);

                 // initialize parser classes

                 parser.Init();

                 // process files

                 try
                 {
                         parser.Process();
                 }
                 catch(IllegalStateException e)
                 {
                         System.err.println(e);
                 }
         }

         public void Init()
         {
                 if(!inited_)
                 {
                         inited_ = true;
                         props_ = System.getProperties();
                         file_sep_ = props_.getProperty("file.separator");
                         pkg_ = null;
                         import_set_ = new SequencedSet();
                         type_set_ = new SequencedSet();
                         var_set_ = new HashSet();
                         class_decls_ = new SequencedSet();
                         inner_decls_ = new HashSet();
                         class_name_ = null;
                         class_depth_name_ = null;
                         outermost_class_name_ = null;
                         xtnds_ = "";
                         impls_ = "";
                         tgt_ = null;
                         prev_anon_ = null;
                         anon_cnt_ = 0;

                         if($.dbug)
                         {
                                 $.ver = true;
                                 $.prof = true;
                         }

                         if($.ver)
                                 PrintDbugln(version_);

                         if($.dbug)
                                 $.List(DbugWriter());

                         try
                         {
                                 // create dependency graph analyzer

                                 dg_ = new DependencyGraph();
                         }
                         catch(Exception e)
                         {
                                 PrintErrln(e);
                                 System.exit(-1);
                         }
                 }
         }

         public void Process()
                 throws IllegalStateException
         {
                 if(!inited_)
                         throw
                         new IllegalStateException("Init() must proceed Process()");

                 // process files one at a time

                 StringTokenizer file_toker = $.Tokenize("files");

                 while(file_toker.hasMoreTokens())
                 {
                         file_name_ = file_toker.nextToken();

                         if($.prof && ErrWriter() != ProfWriter())
                                 PrintProfln("\n--- "+file_name_+" ---");

                         PrintErrln("\n--- "+file_name_+" ---");

                         try
                         {
                                 try
                                 {
                                         ips_ = new FileInputStream(file_name_);
                                 }
                                 catch(FileNotFoundException e)
                                 {
                                         PrintErrln("File not found");
                                         continue;
                                 }

                                 // reset parser state

                                 ReInit(ips_);
                                 dg_.Reset();
                                 import_set_.Clear();
                                 type_set_.Clear();
                                 var_set_ = new HashSet();
                                 class_decls_.Clear();
                                 inner_decls_.clear();
                                 pkg_ = null;

                                 // parse the source file

                                 CompilationUnit();

                                 // close the file that was opened for read

                                 ips_.close();

                                 // begin dependency analysis

                                 // add the source file name

                                 dg_.AddSource(file_name_);

                                 // add the package declaration if any

                                 dg_.AddPackage(pkg_, file_name_, lno_);

                                 // add the import declarations if any

                                 for(
                                         Enumeration itr = import_set_.Iterator();
                                         itr.hasMoreElements();
                                    )
                                 {
                                         Imp imp = (Imp)itr.nextElement();

                                         try
                                         {
                                                 dg_.AddImport(imp);
                                         }
                                         catch(MissingClsPthEntException e)
                                         {
                                                 dg_.WarningsAppend(
                                                                         "["+imp.FileAndLine()+"] declared "
                                                                         +e.getMessage()
                                                                 );
                                         }
                                 }

                                 // add targets (declared classes)

                                 dg_.AddTargets(class_decls_);

                                 // add vars (declared variables)

                                 dg_.AddVars(var_set_);

                                 // add all the dependencies discovered during analysis

                                 Type    type = null;
                                 String          type_name_1st_node = null;
                                 int             di;

                                 for(
                                         Enumeration itr = type_set_.Iterator();
                                         itr.hasMoreElements();
                                    )
                                 {
                                         type = (Type)itr.nextElement();

                                         type.SetBaseCls(dg_.FullClsName(type.BaseCls()));

                                         /*
						type.name is not a dependency
						if it is a variable name or
						a class declared within this
						.java source file!
					*/

                                         if($.dbug)
                                                 PrintDbugln("Process: "+type.Dump());

                                         if((di = type.Name().indexOf('.')) > 0)
                                         {
                                                 type_name_1st_node = type.Name().substring(0, di);
                                         }
                                         else
                                         {
                                                 type_name_1st_node = type.Name();
                                         }

                                         if(
                                                 var_set_.get(type_name_1st_node) == null
                                                 &&
                                                 !class_decls_.Contains(type.Name().replace('.','$'))
                                                 &&
                                                 inner_decls_.get(type_name_1st_node) == null
                                                 )
                                         {
                                                 if(di > 0)
                                                 {
                                                         dg_.AddPfxdDep(type);
                                                 }
                                                 else
                                                 {
                                                         dg_.AddDep(type);
                                                 }
                                         }
                                 }
                         }
                         catch(Exception e)
                         {
                                 PrintErrln(e);
                                 System.exit(-1);
                         }
                 } // end while

                 // resolve all intra package dependencies

                 dg_.ResolveDeps();

                 // display the dependency graph for all source files

                 dg_.ShowGraph();

                 // display the make all dependencies rule if desired

                 dg_.ShowAllRule();
         }

         private String DiscardWhiteSpace(String str)
         {
                 char tmp_from[] = str.toCharArray();
                 int     tmp_from_len = tmp_from.length;
                 char tmp_to[] = new char[tmp_from_len];
                 int i,j;

                 for(i=0, j=0; i < tmp_from_len; i++)
                 {
                         if(
                                 tmp_from[i] == ' '
                                 ||
                                 tmp_from[i] == '\t'
                                 ||
                                 tmp_from[i] == '\n'
                                 ||
                                 tmp_from[i] == '\r'
                                 ||
                                 tmp_from[i] == '\f'
                           )
                         {;}
                         else
                         {
                                 tmp_to[j++] = tmp_from[i];
                         }
                 }

                 return new String(tmp_to);
         }

         private void PopClassName()
         {
                 int di = class_name_.lastIndexOf('$');

                 if(di > 0)
                 {
                         class_name_ = class_name_.substring(0, di);
                 }
         }

         private void SetBaseCls()
         {
                 InrDecl inr_decl = (InrDecl)inner_decls_.get(xtnds_);

                 if(inr_decl != null)
                         xtnds_ = inr_decl.FullName();

                 tgt_.SetBaseCls(xtnds_);

                 if($.prof)
                         PrintProfln(
                                                 lno_
                                                 +" class "
                                                 +tgt_.Name()
                                                 +" extends "
                                                 +tgt_.BaseCls()
                                                 );
         }

         private void BuildTgt(String name, String context)
         {
                 String          tgt_name = null;

                 impls_ = "";

                 if(context.equals("NestedClassDeclaration"))
                 {
                         xtnds_ = "";
                         tgt_name = class_name_ = class_name_.concat("$").concat(name);
                         inner_decls_.add(new InrDecl(name, class_name_));
                         tgt_ = new Tgt(tgt_name);
                 }
                 else
                 {
                         tgt_name = name;
                         tgt_ = new Tgt(tgt_name);

                         if(!context.equals("AnonymousClassDeclaration"))
                         {
                                 xtnds_ = "";
                                 outermost_class_name_ = class_name_ = name;
                         }
                 }

                 if($.prof)
                         PrintProfln(
                                 lno_
                                 +" ClassDecl("+context+")="+tgt_name
                                 );

                 if(context.equals("AnonymousClassDeclaration"))
                         SetBaseCls();

                 class_decls_.Append(tgt_);
         }

         private void BuildType(String name, String context)
         {
                 if(name != null)
                 {
                         if($.prof) PrintProfln(lno_+" PossibleType("+context+")="+name);

                         if(!context.startsWith("LA:"))
                         {
                                 String type_name = null;
                                 int idx;

                                 if(context.equals("PrimaryPrefix"))
                                 {
                                         if((idx = name.lastIndexOf('.')) > 0)
                                         {
                                                 type_name = name.substring(0, idx);
                                         }
                                 }
                                 else
                                 {
                                         String inner_name = name.replace('.', '$');

                                         if(
                                                 !class_decls_
                                                 .Contains(outermost_class_name_+"$"+inner_name)
                                                 &&
                                                 !class_decls_
                                                 .Contains(inner_name)
                                           )
                                         {
                                                 type_name = name;
                                         }
                                 }

                                 if(type_name != null)
                                 {
                                         if($.prof) PrintProfln("Adding PossibleType="+type_name);
                                         type_set_
                                         .Append(new Type(type_name+".class", context, xtnds_, file_name_, lno_));
                                 }
                         }
                 }
         }

/*****************************************
 * THE JAVA LANGUAGE GRAMMAR STARTS HERE *
 *****************************************/

/*
 * Program structuring syntax follows.
 */
  final public void CompilationUnit() throws ParseError {
    if (jj_mask_0[getToken(1).kind]) {
      PackageDeclaration();
    } else {
      jj_expLA1[0] = jj_gen;
      ;
    }
    label_1:
    while (true) {
      if (jj_mask_1[getToken(1).kind]) {
        ;
      } else {
        jj_expLA1[1] = jj_gen;
        break label_1;
      }
      ImportDeclaration();
    }
    label_2:
    while (true) {
      if (jj_mask_2[getToken(1).kind]) {
        ;
      } else {
        jj_expLA1[2] = jj_gen;
        break label_2;
      }
      TypeDeclaration();
    }
    jj_consume_token(0);
  }

  static boolean[] jj_mask_0 = new boolean[117];
  static {
    jj_mask_0[PACKAGE] = true;
  }
  static boolean[] jj_mask_1 = new boolean[117];
  static {
    jj_mask_1[IMPORT] = true;
  }
  static boolean[] jj_mask_2 = new boolean[117];
  static {
    jj_mask_2[ABSTRACT] =
    jj_mask_2[CLASS] =
    jj_mask_2[FINAL] =
    jj_mask_2[INTERFACE] =
    jj_mask_2[PUBLIC] =
    jj_mask_2[SEMICOLON] = true;
  }
  
  final public void PackageDeclaration() throws ParseError {
    jj_consume_token(PACKAGE);
                   lno_=token.beginLine;
    pkg_ = Name();
    jj_consume_token(SEMICOLON);
          if($.prof) PrintProfln(lno_+" PackageName="+pkg_);
  }

  final public void ImportDeclaration() throws ParseError {
 StrBuf sbuf = new StrBuf();String name;String nws_sbuf;
    jj_consume_token(IMPORT);
                  lno_=token.beginLine;
    name = Name();
                     sbuf.Assign(name);
    if (jj_mask_3[getToken(1).kind]) {
      jj_consume_token(DOTSTAR);
                    sbuf.Append(token.image);
    } else {
      jj_expLA1[3] = jj_gen;
      ;
    }
    jj_consume_token(SEMICOLON);
                 nws_sbuf = DiscardWhiteSpace(sbuf.toString());
                 if($.prof) PrintProfln(lno_+" ImportName="+nws_sbuf);
                 import_set_.Append(new Imp(nws_sbuf, file_name_, lno_));
  }

  static boolean[] jj_mask_3 = new boolean[117];
  static {
    jj_mask_3[DOTSTAR] = true;
  }
  
  final public void TypeDeclaration() throws ParseError {
    if (jj_2_1(2147483647)) {
      ClassDeclaration();
    } else {
      if (jj_mask_5[getToken(1).kind]) {
        InterfaceDeclaration();
      } else {
        jj_expLA1[5] = jj_gen;
        if (jj_mask_4[getToken(1).kind]) {
          jj_consume_token(SEMICOLON);
        } else {
          jj_expLA1[4] = jj_gen;
          jj_consume_token(-1);
          throw new ParseError();
        }
      }
    }
  }

  static boolean[] jj_mask_4 = new boolean[117];
  static {
    jj_mask_4[SEMICOLON] = true;
  }
  static boolean[] jj_mask_5 = new boolean[117];
  static {
    jj_mask_5[ABSTRACT] =
    jj_mask_5[INTERFACE] =
    jj_mask_5[PUBLIC] = true;
  }
  
/*
 * Declaration syntax follows.
 */
  final public void ClassDeclaration() throws ParseError {
    label_3:
    while (true) {
      if (jj_mask_6[getToken(1).kind]) {
        ;
      } else {
        jj_expLA1[6] = jj_gen;
        break label_3;
      }
      if (jj_mask_9[getToken(1).kind]) {
        jj_consume_token(ABSTRACT);
      } else {
        jj_expLA1[9] = jj_gen;
        if (jj_mask_8[getToken(1).kind]) {
          jj_consume_token(FINAL);
        } else {
          jj_expLA1[8] = jj_gen;
          if (jj_mask_7[getToken(1).kind]) {
            jj_consume_token(PUBLIC);
          } else {
            jj_expLA1[7] = jj_gen;
            jj_consume_token(-1);
            throw new ParseError();
          }
        }
      }
    }
    UnmodifiedClassDeclaration("ClassDeclaration");
  }

  static boolean[] jj_mask_6 = new boolean[117];
  static {
    jj_mask_6[ABSTRACT] =
    jj_mask_6[FINAL] =
    jj_mask_6[PUBLIC] = true;
  }
  static boolean[] jj_mask_7 = new boolean[117];
  static {
    jj_mask_7[PUBLIC] = true;
  }
  static boolean[] jj_mask_8 = new boolean[117];
  static {
    jj_mask_8[FINAL] = true;
  }
  static boolean[] jj_mask_9 = new boolean[117];
  static {
    jj_mask_9[ABSTRACT] = true;
  }
  
  final public void UnmodifiedClassDeclaration(String context) throws ParseError {
    jj_consume_token(CLASS);
          lno_=token.beginLine;
    jj_consume_token(IDENTIFIER);
                 BuildTgt(token.image, context);
    if (jj_mask_10[getToken(1).kind]) {
      jj_consume_token(EXTENDS);
      xtnds_ = Type("UnmodifiedClassExtendsDeclaration");
          SetBaseCls();
    } else {
      jj_expLA1[10] = jj_gen;
      ;
    }
    if (jj_mask_11[getToken(1).kind]) {
      jj_consume_token(IMPLEMENTS);
      TypeList("UnmodifiedClassImplementsDeclaration");
    } else {
      jj_expLA1[11] = jj_gen;
      ;
    }
    ClassBody();
  }

  static boolean[] jj_mask_10 = new boolean[117];
  static {
    jj_mask_10[EXTENDS] = true;
  }
  static boolean[] jj_mask_11 = new boolean[117];
  static {
    jj_mask_11[IMPLEMENTS] = true;
  }
  
  final public void ClassBody() throws ParseError {
    jj_consume_token(LBRACE);
    label_4:
    while (true) {
      if (jj_mask_12[getToken(1).kind]) {
        ;
      } else {
        jj_expLA1[12] = jj_gen;
        break label_4;
      }
      ClassBodyDeclaration();
    }
    jj_consume_token(RBRACE);
  }

  static boolean[] jj_mask_12 = new boolean[117];
  static {
    jj_mask_12[ABSTRACT] =
    jj_mask_12[BOOLEAN] =
    jj_mask_12[BYTE] =
    jj_mask_12[CHAR] =
    jj_mask_12[CLASS] =
    jj_mask_12[DOUBLE] =
    jj_mask_12[FINAL] =
    jj_mask_12[FLOAT] =
    jj_mask_12[INT] =
    jj_mask_12[INTERFACE] =
    jj_mask_12[LONG] =
    jj_mask_12[NATIVE] =
    jj_mask_12[PRIVATE] =
    jj_mask_12[PROTECTED] =
    jj_mask_12[PUBLIC] =
    jj_mask_12[SHORT] =
    jj_mask_12[STATIC] =
    jj_mask_12[SYNCHRONIZED] =
    jj_mask_12[TRANSIENT] =
    jj_mask_12[VOID] =
    jj_mask_12[VOLATILE] =
    jj_mask_12[IDENTIFIER] =
    jj_mask_12[LBRACE] = true;
  }
  
  final public void NestedClassDeclaration() throws ParseError {
    label_5:
    while (true) {
      if (jj_mask_13[getToken(1).kind]) {
        ;
      } else {
        jj_expLA1[13] = jj_gen;
        break label_5;
      }
      if (jj_mask_19[getToken(1).kind]) {
        jj_consume_token(STATIC);
      } else {
        jj_expLA1[19] = jj_gen;
        if (jj_mask_18[getToken(1).kind]) {
          jj_consume_token(ABSTRACT);
        } else {
          jj_expLA1[18] = jj_gen;
          if (jj_mask_17[getToken(1).kind]) {
            jj_consume_token(FINAL);
          } else {
            jj_expLA1[17] = jj_gen;
            if (jj_mask_16[getToken(1).kind]) {
              jj_consume_token(PUBLIC);
            } else {
              jj_expLA1[16] = jj_gen;
              if (jj_mask_15[getToken(1).kind]) {
                jj_consume_token(PROTECTED);
              } else {
                jj_expLA1[15] = jj_gen;
                if (jj_mask_14[getToken(1).kind]) {
                  jj_consume_token(PRIVATE);
                } else {
                  jj_expLA1[14] = jj_gen;
                  jj_consume_token(-1);
                  throw new ParseError();
                }
              }
            }
          }
        }
      }
    }
    UnmodifiedClassDeclaration("NestedClassDeclaration");
  }

  static boolean[] jj_mask_13 = new boolean[117];
  static {
    jj_mask_13[ABSTRACT] =
    jj_mask_13[FINAL] =
    jj_mask_13[PRIVATE] =
    jj_mask_13[PROTECTED] =
    jj_mask_13[PUBLIC] =
    jj_mask_13[STATIC] = true;
  }
  static boolean[] jj_mask_14 = new boolean[117];
  static {
    jj_mask_14[PRIVATE] = true;
  }
  static boolean[] jj_mask_15 = new boolean[117];
  static {
    jj_mask_15[PROTECTED] = true;
  }
  static boolean[] jj_mask_16 = new boolean[117];
  static {
    jj_mask_16[PUBLIC] = true;
  }
  static boolean[] jj_mask_17 = new boolean[117];
  static {
    jj_mask_17[FINAL] = true;
  }
  static boolean[] jj_mask_18 = new boolean[117];
  static {
    jj_mask_18[ABSTRACT] = true;
  }
  static boolean[] jj_mask_19 = new boolean[117];
  static {
    jj_mask_19[STATIC] = true;
  }
  
  final public void ClassBodyDeclaration() throws ParseError {
    if (jj_2_6(2)) {
      Initializer();
    } else {
      if (jj_2_5(2147483647)) {
        NestedClassDeclaration();
         PopClassName();
      } else {
        if (jj_2_4(2147483647)) {
          NestedInterfaceDeclaration();
         PopClassName();
        } else {
          if (jj_2_3(2147483647)) {
            ConstructorDeclaration();
          } else {
            if (jj_2_2(2147483647)) {
              MethodDeclaration();
            } else {
              if (jj_mask_20[getToken(1).kind]) {
                FieldDeclaration();
              } else {
                jj_expLA1[20] = jj_gen;
                jj_consume_token(-1);
                throw new ParseError();
              }
            }
          }
        }
      }
    }
  }

  static boolean[] jj_mask_20 = new boolean[117];
  static {
    jj_mask_20[BOOLEAN] =
    jj_mask_20[BYTE] =
    jj_mask_20[CHAR] =
    jj_mask_20[DOUBLE] =
    jj_mask_20[FINAL] =
    jj_mask_20[FLOAT] =
    jj_mask_20[INT] =
    jj_mask_20[LONG] =
    jj_mask_20[PRIVATE] =
    jj_mask_20[PROTECTED] =
    jj_mask_20[PUBLIC] =
    jj_mask_20[SHORT] =
    jj_mask_20[STATIC] =
    jj_mask_20[TRANSIENT] =
    jj_mask_20[VOLATILE] =
    jj_mask_20[IDENTIFIER] = true;
  }
  
// This production is to determine lookahead only.
  final public void MethodDeclarationLookahead() throws ParseError {
    label_6:
    while (true) {
      if (jj_mask_21[getToken(1).kind]) {
        ;
      } else {
        jj_expLA1[21] = jj_gen;
        break label_6;
      }
      if (jj_mask_29[getToken(1).kind]) {
        jj_consume_token(PUBLIC);
      } else {
        jj_expLA1[29] = jj_gen;
        if (jj_mask_28[getToken(1).kind]) {
          jj_consume_token(PROTECTED);
        } else {
          jj_expLA1[28] = jj_gen;
          if (jj_mask_27[getToken(1).kind]) {
            jj_consume_token(PRIVATE);
          } else {
            jj_expLA1[27] = jj_gen;
            if (jj_mask_26[getToken(1).kind]) {
              jj_consume_token(STATIC);
            } else {
              jj_expLA1[26] = jj_gen;
              if (jj_mask_25[getToken(1).kind]) {
                jj_consume_token(ABSTRACT);
              } else {
                jj_expLA1[25] = jj_gen;
                if (jj_mask_24[getToken(1).kind]) {
                  jj_consume_token(FINAL);
                } else {
                  jj_expLA1[24] = jj_gen;
                  if (jj_mask_23[getToken(1).kind]) {
                    jj_consume_token(NATIVE);
                  } else {
                    jj_expLA1[23] = jj_gen;
                    if (jj_mask_22[getToken(1).kind]) {
                      jj_consume_token(SYNCHRONIZED);
                    } else {
                      jj_expLA1[22] = jj_gen;
                      jj_consume_token(-1);
                      throw new ParseError();
                    }
                  }
                }
              }
            }
          }
        }
      }
    }
    ResultType();
    jj_consume_token(IDENTIFIER);
    jj_consume_token(LPAREN);
  }

  static boolean[] jj_mask_21 = new boolean[117];
  static {
    jj_mask_21[ABSTRACT] =
    jj_mask_21[FINAL] =
    jj_mask_21[NATIVE] =
    jj_mask_21[PRIVATE] =
    jj_mask_21[PROTECTED] =
    jj_mask_21[PUBLIC] =
    jj_mask_21[STATIC] =
    jj_mask_21[SYNCHRONIZED] = true;
  }
  static boolean[] jj_mask_22 = new boolean[117];
  static {
    jj_mask_22[SYNCHRONIZED] = true;
  }
  static boolean[] jj_mask_23 = new boolean[117];
  static {
    jj_mask_23[NATIVE] = true;
  }
  static boolean[] jj_mask_24 = new boolean[117];
  static {
    jj_mask_24[FINAL] = true;
  }
  static boolean[] jj_mask_25 = new boolean[117];
  static {
    jj_mask_25[ABSTRACT] = true;
  }
  static boolean[] jj_mask_26 = new boolean[117];
  static {
    jj_mask_26[STATIC] = true;
  }
  static boolean[] jj_mask_27 = new boolean[117];
  static {
    jj_mask_27[PRIVATE] = true;
  }
  static boolean[] jj_mask_28 = new boolean[117];
  static {
    jj_mask_28[PROTECTED] = true;
  }
  static boolean[] jj_mask_29 = new boolean[117];
  static {
    jj_mask_29[PUBLIC] = true;
  }
  
  final public void InterfaceDeclaration() throws ParseError {
    label_7:
    while (true) {
      if (jj_mask_30[getToken(1).kind]) {
        ;
      } else {
        jj_expLA1[30] = jj_gen;
        break label_7;
      }
      if (jj_mask_32[getToken(1).kind]) {
        jj_consume_token(ABSTRACT);
      } else {
        jj_expLA1[32] = jj_gen;
        if (jj_mask_31[getToken(1).kind]) {
          jj_consume_token(PUBLIC);
        } else {
          jj_expLA1[31] = jj_gen;
          jj_consume_token(-1);
          throw new ParseError();
        }
      }
    }
    UnmodifiedInterfaceDeclaration("InterfaceDeclaration");
  }

  static boolean[] jj_mask_30 = new boolean[117];
  static {
    jj_mask_30[ABSTRACT] =
    jj_mask_30[PUBLIC] = true;
  }
  static boolean[] jj_mask_31 = new boolean[117];
  static {
    jj_mask_31[PUBLIC] = true;
  }
  static boolean[] jj_mask_32 = new boolean[117];
  static {
    jj_mask_32[ABSTRACT] = true;
  }
  
  final public void NestedInterfaceDeclaration() throws ParseError {
    label_8:
    while (true) {
      if (jj_mask_33[getToken(1).kind]) {
        ;
      } else {
        jj_expLA1[33] = jj_gen;
        break label_8;
      }
      if (jj_mask_39[getToken(1).kind]) {
        jj_consume_token(STATIC);
      } else {
        jj_expLA1[39] = jj_gen;
        if (jj_mask_38[getToken(1).kind]) {
          jj_consume_token(ABSTRACT);
        } else {
          jj_expLA1[38] = jj_gen;
          if (jj_mask_37[getToken(1).kind]) {
            jj_consume_token(FINAL);
          } else {
            jj_expLA1[37] = jj_gen;
            if (jj_mask_36[getToken(1).kind]) {
              jj_consume_token(PUBLIC);
            } else {
              jj_expLA1[36] = jj_gen;
              if (jj_mask_35[getToken(1).kind]) {
                jj_consume_token(PROTECTED);
              } else {
                jj_expLA1[35] = jj_gen;
                if (jj_mask_34[getToken(1).kind]) {
                  jj_consume_token(PRIVATE);
                } else {
                  jj_expLA1[34] = jj_gen;
                  jj_consume_token(-1);
                  throw new ParseError();
                }
              }
            }
          }
        }
      }
    }
    UnmodifiedInterfaceDeclaration("NestedInterfaceDeclaration");
  }

  static boolean[] jj_mask_33 = new boolean[117];
  static {
    jj_mask_33[ABSTRACT] =
    jj_mask_33[FINAL] =
    jj_mask_33[PRIVATE] =
    jj_mask_33[PROTECTED] =
    jj_mask_33[PUBLIC] =
    jj_mask_33[STATIC] = true;
  }
  static boolean[] jj_mask_34 = new boolean[117];
  static {
    jj_mask_34[PRIVATE] = true;
  }
  static boolean[] jj_mask_35 = new boolean[117];
  static {
    jj_mask_35[PROTECTED] = true;
  }
  static boolean[] jj_mask_36 = new boolean[117];
  static {
    jj_mask_36[PUBLIC] = true;
  }
  static boolean[] jj_mask_37 = new boolean[117];
  static {
    jj_mask_37[FINAL] = true;
  }
  static boolean[] jj_mask_38 = new boolean[117];
  static {
    jj_mask_38[ABSTRACT] = true;
  }
  static boolean[] jj_mask_39 = new boolean[117];
  static {
    jj_mask_39[STATIC] = true;
  }
  
  final public void UnmodifiedInterfaceDeclaration(String context) throws ParseError {
 String name=null;
    jj_consume_token(INTERFACE);
              lno_=token.beginLine;
    jj_consume_token(IDENTIFIER);
                 name=token.image;

                 if(context.equals("NestedInterfaceDeclaration"))
                 {
                         class_name_ = class_name_.concat("$").concat(name);
                         inner_decls_.add(new InrDecl(name, class_name_));
                 }
                 else
                 {
                         outermost_class_name_ = class_name_ = name;
                 }

                 class_decls_.Append(new Tgt(class_name_));
   if($.prof) PrintProfln(lno_+" InterfaceDecl="+class_name_);
    if (jj_mask_40[getToken(1).kind]) {
      jj_consume_token(EXTENDS);
      TypeList("UnmodifiedInterfaceExtendsDeclaration");
    } else {
      jj_expLA1[40] = jj_gen;
      ;
    }
    jj_consume_token(LBRACE);
    label_9:
    while (true) {
      if (jj_mask_41[getToken(1).kind]) {
        ;
      } else {
        jj_expLA1[41] = jj_gen;
        break label_9;
      }
      InterfaceMemberDeclaration();
    }
    jj_consume_token(RBRACE);
  }

  static boolean[] jj_mask_40 = new boolean[117];
  static {
    jj_mask_40[EXTENDS] = true;
  }
  static boolean[] jj_mask_41 = new boolean[117];
  static {
    jj_mask_41[ABSTRACT] =
    jj_mask_41[BOOLEAN] =
    jj_mask_41[BYTE] =
    jj_mask_41[CHAR] =
    jj_mask_41[CLASS] =
    jj_mask_41[DOUBLE] =
    jj_mask_41[FINAL] =
    jj_mask_41[FLOAT] =
    jj_mask_41[INT] =
    jj_mask_41[INTERFACE] =
    jj_mask_41[LONG] =
    jj_mask_41[NATIVE] =
    jj_mask_41[PRIVATE] =
    jj_mask_41[PROTECTED] =
    jj_mask_41[PUBLIC] =
    jj_mask_41[SHORT] =
    jj_mask_41[STATIC] =
    jj_mask_41[SYNCHRONIZED] =
    jj_mask_41[TRANSIENT] =
    jj_mask_41[VOID] =
    jj_mask_41[VOLATILE] =
    jj_mask_41[IDENTIFIER] = true;
  }
  
  final public void InterfaceMemberDeclaration() throws ParseError {
    if (jj_2_9(2147483647)) {
      NestedClassDeclaration();
         PopClassName();
    } else {
      if (jj_2_8(2147483647)) {
        NestedInterfaceDeclaration();
         PopClassName();
      } else {
        if (jj_2_7(2147483647)) {
          MethodDeclaration();
        } else {
          if (jj_mask_42[getToken(1).kind]) {
            FieldDeclaration();
          } else {
            jj_expLA1[42] = jj_gen;
            jj_consume_token(-1);
            throw new ParseError();
          }
        }
      }
    }
  }

  static boolean[] jj_mask_42 = new boolean[117];
  static {
    jj_mask_42[BOOLEAN] =
    jj_mask_42[BYTE] =
    jj_mask_42[CHAR] =
    jj_mask_42[DOUBLE] =
    jj_mask_42[FINAL] =
    jj_mask_42[FLOAT] =
    jj_mask_42[INT] =
    jj_mask_42[LONG] =
    jj_mask_42[PRIVATE] =
    jj_mask_42[PROTECTED] =
    jj_mask_42[PUBLIC] =
    jj_mask_42[SHORT] =
    jj_mask_42[STATIC] =
    jj_mask_42[TRANSIENT] =
    jj_mask_42[VOLATILE] =
    jj_mask_42[IDENTIFIER] = true;
  }
  
  final public void FieldDeclaration() throws ParseError {
    label_10:
    while (true) {
      if (jj_mask_43[getToken(1).kind]) {
        ;
      } else {
        jj_expLA1[43] = jj_gen;
        break label_10;
      }
      if (jj_mask_50[getToken(1).kind]) {
        jj_consume_token(PUBLIC);
      } else {
        jj_expLA1[50] = jj_gen;
        if (jj_mask_49[getToken(1).kind]) {
          jj_consume_token(PROTECTED);
        } else {
          jj_expLA1[49] = jj_gen;
          if (jj_mask_48[getToken(1).kind]) {
            jj_consume_token(PRIVATE);
          } else {
            jj_expLA1[48] = jj_gen;
            if (jj_mask_47[getToken(1).kind]) {
              jj_consume_token(STATIC);
            } else {
              jj_expLA1[47] = jj_gen;
              if (jj_mask_46[getToken(1).kind]) {
                jj_consume_token(FINAL);
              } else {
                jj_expLA1[46] = jj_gen;
                if (jj_mask_45[getToken(1).kind]) {
                  jj_consume_token(TRANSIENT);
                } else {
                  jj_expLA1[45] = jj_gen;
                  if (jj_mask_44[getToken(1).kind]) {
                    jj_consume_token(VOLATILE);
                  } else {
                    jj_expLA1[44] = jj_gen;
                    jj_consume_token(-1);
                    throw new ParseError();
                  }
                }
              }
            }
          }
        }
      }
    }
    Type("FieldDeclaration");
    VariableDeclarator();
    label_11:
    while (true) {
      if (jj_mask_51[getToken(1).kind]) {
        ;
      } else {
        jj_expLA1[51] = jj_gen;
        break label_11;
      }
      jj_consume_token(COMMA);
      VariableDeclarator();
    }
    jj_consume_token(SEMICOLON);
  }

  static boolean[] jj_mask_43 = new boolean[117];
  static {
    jj_mask_43[FINAL] =
    jj_mask_43[PRIVATE] =
    jj_mask_43[PROTECTED] =
    jj_mask_43[PUBLIC] =
    jj_mask_43[STATIC] =
    jj_mask_43[TRANSIENT] =
    jj_mask_43[VOLATILE] = true;
  }
  static boolean[] jj_mask_44 = new boolean[117];
  static {
    jj_mask_44[VOLATILE] = true;
  }
  static boolean[] jj_mask_45 = new boolean[117];
  static {
    jj_mask_45[TRANSIENT] = true;
  }
  static boolean[] jj_mask_46 = new boolean[117];
  static {
    jj_mask_46[FINAL] = true;
  }
  static boolean[] jj_mask_47 = new boolean[117];
  static {
    jj_mask_47[STATIC] = true;
  }
  static boolean[] jj_mask_48 = new boolean[117];
  static {
    jj_mask_48[PRIVATE] = true;
  }
  static boolean[] jj_mask_49 = new boolean[117];
  static {
    jj_mask_49[PROTECTED] = true;
  }
  static boolean[] jj_mask_50 = new boolean[117];
  static {
    jj_mask_50[PUBLIC] = true;
  }
  static boolean[] jj_mask_51 = new boolean[117];
  static {
    jj_mask_51[COMMA] = true;
  }
  
  final public void VariableDeclarator() throws ParseError {
    VariableDeclaratorId();
    if (jj_mask_52[getToken(1).kind]) {
      jj_consume_token(ASSIGN);
      VariableInitializer();
    } else {
      jj_expLA1[52] = jj_gen;
      ;
    }
  }

  static boolean[] jj_mask_52 = new boolean[117];
  static {
    jj_mask_52[ASSIGN] = true;
  }
  
  final public void VariableDeclaratorId() throws ParseError {
    jj_consume_token(IDENTIFIER);
         Var var = new Var(token.image, class_name_, file_name_, token.beginLine);
         if($.prof)
                 PrintProfln(token.beginLine+" Variable="+token.image);
         var_set_.add(var);
    label_12:
    while (true) {
      if (jj_mask_53[getToken(1).kind]) {
        ;
      } else {
        jj_expLA1[53] = jj_gen;
        break label_12;
      }
      jj_consume_token(LBRACKET);
      jj_consume_token(RBRACKET);
    }
  }

  static boolean[] jj_mask_53 = new boolean[117];
  static {
    jj_mask_53[LBRACKET] = true;
  }
  
  final public void VariableInitializer() throws ParseError {
    if (jj_mask_55[getToken(1).kind]) {
      ArrayInitializer();
    } else {
      jj_expLA1[55] = jj_gen;
      if (jj_mask_54[getToken(1).kind]) {
        Expression();
      } else {
        jj_expLA1[54] = jj_gen;
        jj_consume_token(-1);
        throw new ParseError();
      }
    }
  }

  static boolean[] jj_mask_54 = new boolean[117];
  static {
    jj_mask_54[BOOLEAN] =
    jj_mask_54[BYTE] =
    jj_mask_54[CHAR] =
    jj_mask_54[DOUBLE] =
    jj_mask_54[FALSE] =
    jj_mask_54[FLOAT] =
    jj_mask_54[INT] =
    jj_mask_54[LONG] =
    jj_mask_54[NEW] =
    jj_mask_54[NULL] =
    jj_mask_54[SHORT] =
    jj_mask_54[SUPER] =
    jj_mask_54[THIS] =
    jj_mask_54[TRUE] =
    jj_mask_54[INTEGER_LITERAL] =
    jj_mask_54[FLOATING_POINT_LITERAL] =
    jj_mask_54[CHARACTER_LITERAL] =
    jj_mask_54[STRING_LITERAL] =
    jj_mask_54[IDENTIFIER] =
    jj_mask_54[LPAREN] =
    jj_mask_54[BANG] =
    jj_mask_54[TILDE] =
    jj_mask_54[INCR] =
    jj_mask_54[DECR] =
    jj_mask_54[PLUS] =
    jj_mask_54[MINUS] = true;
  }
  static boolean[] jj_mask_55 = new boolean[117];
  static {
    jj_mask_55[LBRACE] = true;
  }
  
  final public void ArrayInitializer() throws ParseError {
    jj_consume_token(LBRACE);
    if (jj_mask_56[getToken(1).kind]) {
      VariableInitializer();
      label_13:
      while (true) {
        if (jj_2_10(2)) {
          ;
        } else {
          break label_13;
        }
        jj_consume_token(COMMA);
        VariableInitializer();
      }
    } else {
      jj_expLA1[56] = jj_gen;
      ;
    }
    if (jj_mask_57[getToken(1).kind]) {
      jj_consume_token(COMMA);
    } else {
      jj_expLA1[57] = jj_gen;
      ;
    }
    jj_consume_token(RBRACE);
  }

  static boolean[] jj_mask_56 = new boolean[117];
  static {
    jj_mask_56[BOOLEAN] =
    jj_mask_56[BYTE] =
    jj_mask_56[CHAR] =
    jj_mask_56[DOUBLE] =
    jj_mask_56[FALSE] =
    jj_mask_56[FLOAT] =
    jj_mask_56[INT] =
    jj_mask_56[LONG] =
    jj_mask_56[NEW] =
    jj_mask_56[NULL] =
    jj_mask_56[SHORT] =
    jj_mask_56[SUPER] =
    jj_mask_56[THIS] =
    jj_mask_56[TRUE] =
    jj_mask_56[INTEGER_LITERAL] =
    jj_mask_56[FLOATING_POINT_LITERAL] =
    jj_mask_56[CHARACTER_LITERAL] =
    jj_mask_56[STRING_LITERAL] =
    jj_mask_56[IDENTIFIER] =
    jj_mask_56[LPAREN] =
    jj_mask_56[LBRACE] =
    jj_mask_56[BANG] =
    jj_mask_56[TILDE] =
    jj_mask_56[INCR] =
    jj_mask_56[DECR] =
    jj_mask_56[PLUS] =
    jj_mask_56[MINUS] = true;
  }
  static boolean[] jj_mask_57 = new boolean[117];
  static {
    jj_mask_57[COMMA] = true;
  }
  
  final public void MethodDeclaration() throws ParseError {
    label_14:
    while (true) {
      if (jj_mask_58[getToken(1).kind]) {
        ;
      } else {
        jj_expLA1[58] = jj_gen;
        break label_14;
      }
      if (jj_mask_66[getToken(1).kind]) {
        jj_consume_token(PUBLIC);
      } else {
        jj_expLA1[66] = jj_gen;
        if (jj_mask_65[getToken(1).kind]) {
          jj_consume_token(PROTECTED);
        } else {
          jj_expLA1[65] = jj_gen;
          if (jj_mask_64[getToken(1).kind]) {
            jj_consume_token(PRIVATE);
          } else {
            jj_expLA1[64] = jj_gen;
            if (jj_mask_63[getToken(1).kind]) {
              jj_consume_token(STATIC);
            } else {
              jj_expLA1[63] = jj_gen;
              if (jj_mask_62[getToken(1).kind]) {
                jj_consume_token(ABSTRACT);
              } else {
                jj_expLA1[62] = jj_gen;
                if (jj_mask_61[getToken(1).kind]) {
                  jj_consume_token(FINAL);
                } else {
                  jj_expLA1[61] = jj_gen;
                  if (jj_mask_60[getToken(1).kind]) {
                    jj_consume_token(NATIVE);
                  } else {
                    jj_expLA1[60] = jj_gen;
                    if (jj_mask_59[getToken(1).kind]) {
                      jj_consume_token(SYNCHRONIZED);
                    } else {
                      jj_expLA1[59] = jj_gen;
                      jj_consume_token(-1);
                      throw new ParseError();
                    }
                  }
                }
              }
            }
          }
        }
      }
    }
    ResultType();
    MethodDeclarator();
    if (jj_mask_67[getToken(1).kind]) {
      jj_consume_token(THROWS);
      TypeList("MethodThrowsDeclaration");
    } else {
      jj_expLA1[67] = jj_gen;
      ;
    }
    if (jj_mask_69[getToken(1).kind]) {
      Block();
    } else {
      jj_expLA1[69] = jj_gen;
      if (jj_mask_68[getToken(1).kind]) {
        jj_consume_token(SEMICOLON);
      } else {
        jj_expLA1[68] = jj_gen;
        jj_consume_token(-1);
        throw new ParseError();
      }
    }
  }

  static boolean[] jj_mask_58 = new boolean[117];
  static {
    jj_mask_58[ABSTRACT] =
    jj_mask_58[FINAL] =
    jj_mask_58[NATIVE] =
    jj_mask_58[PRIVATE] =
    jj_mask_58[PROTECTED] =
    jj_mask_58[PUBLIC] =
    jj_mask_58[STATIC] =
    jj_mask_58[SYNCHRONIZED] = true;
  }
  static boolean[] jj_mask_59 = new boolean[117];
  static {
    jj_mask_59[SYNCHRONIZED] = true;
  }
  static boolean[] jj_mask_60 = new boolean[117];
  static {
    jj_mask_60[NATIVE] = true;
  }
  static boolean[] jj_mask_61 = new boolean[117];
  static {
    jj_mask_61[FINAL] = true;
  }
  static boolean[] jj_mask_62 = new boolean[117];
  static {
    jj_mask_62[ABSTRACT] = true;
  }
  static boolean[] jj_mask_63 = new boolean[117];
  static {
    jj_mask_63[STATIC] = true;
  }
  static boolean[] jj_mask_64 = new boolean[117];
  static {
    jj_mask_64[PRIVATE] = true;
  }
  static boolean[] jj_mask_65 = new boolean[117];
  static {
    jj_mask_65[PROTECTED] = true;
  }
  static boolean[] jj_mask_66 = new boolean[117];
  static {
    jj_mask_66[PUBLIC] = true;
  }
  static boolean[] jj_mask_67 = new boolean[117];
  static {
    jj_mask_67[THROWS] = true;
  }
  static boolean[] jj_mask_68 = new boolean[117];
  static {
    jj_mask_68[SEMICOLON] = true;
  }
  static boolean[] jj_mask_69 = new boolean[117];
  static {
    jj_mask_69[LBRACE] = true;
  }
  
  final public void MethodDeclarator() throws ParseError {
    jj_consume_token(IDENTIFIER);
    FormalParameters();
    label_15:
    while (true) {
      if (jj_mask_70[getToken(1).kind]) {
        ;
      } else {
        jj_expLA1[70] = jj_gen;
        break label_15;
      }
      jj_consume_token(LBRACKET);
      jj_consume_token(RBRACKET);
    }
  }

  static boolean[] jj_mask_70 = new boolean[117];
  static {
    jj_mask_70[LBRACKET] = true;
  }
  
  final public void FormalParameters() throws ParseError {
    jj_consume_token(LPAREN);
    if (jj_mask_72[getToken(1).kind]) {
      FormalParameter();
      label_16:
      while (true) {
        if (jj_mask_71[getToken(1).kind]) {
          ;
        } else {
          jj_expLA1[71] = jj_gen;
          break label_16;
        }
        jj_consume_token(COMMA);
        FormalParameter();
      }
    } else {
      jj_expLA1[72] = jj_gen;
      ;
    }
    jj_consume_token(RPAREN);
  }

  static boolean[] jj_mask_71 = new boolean[117];
  static {
    jj_mask_71[COMMA] = true;
  }
  static boolean[] jj_mask_72 = new boolean[117];
  static {
    jj_mask_72[BOOLEAN] =
    jj_mask_72[BYTE] =
    jj_mask_72[CHAR] =
    jj_mask_72[DOUBLE] =
    jj_mask_72[FINAL] =
    jj_mask_72[FLOAT] =
    jj_mask_72[INT] =
    jj_mask_72[LONG] =
    jj_mask_72[SHORT] =
    jj_mask_72[IDENTIFIER] = true;
  }
  
  final public void FormalParameter() throws ParseError {
    if (jj_mask_73[getToken(1).kind]) {
      jj_consume_token(FINAL);
    } else {
      jj_expLA1[73] = jj_gen;
      ;
    }
    Type("FormalParameter");
    VariableDeclaratorId();
  }

  static boolean[] jj_mask_73 = new boolean[117];
  static {
    jj_mask_73[FINAL] = true;
  }
  
  final public void ConstructorDeclaration() throws ParseError {
    if (jj_mask_77[getToken(1).kind]) {
      if (jj_mask_76[getToken(1).kind]) {
        jj_consume_token(PUBLIC);
      } else {
        jj_expLA1[76] = jj_gen;
        if (jj_mask_75[getToken(1).kind]) {
          jj_consume_token(PROTECTED);
        } else {
          jj_expLA1[75] = jj_gen;
          if (jj_mask_74[getToken(1).kind]) {
            jj_consume_token(PRIVATE);
          } else {
            jj_expLA1[74] = jj_gen;
            jj_consume_token(-1);
            throw new ParseError();
          }
        }
      }
    } else {
      jj_expLA1[77] = jj_gen;
      ;
    }
    jj_consume_token(IDENTIFIER);
    FormalParameters();
    if (jj_mask_78[getToken(1).kind]) {
      jj_consume_token(THROWS);
      TypeList("ConstructorThrowsDeclaration");
    } else {
      jj_expLA1[78] = jj_gen;
      ;
    }
    jj_consume_token(LBRACE);
    if (jj_2_11(2147483647)) {
      ExplicitConstructorInvocation();
    } else {
      ;
    }
    label_17:
    while (true) {
      if (jj_mask_79[getToken(1).kind]) {
        ;
      } else {
        jj_expLA1[79] = jj_gen;
        break label_17;
      }
      BlockStatement();
    }
    jj_consume_token(RBRACE);
  }

  static boolean[] jj_mask_74 = new boolean[117];
  static {
    jj_mask_74[PRIVATE] = true;
  }
  static boolean[] jj_mask_75 = new boolean[117];
  static {
    jj_mask_75[PROTECTED] = true;
  }
  static boolean[] jj_mask_76 = new boolean[117];
  static {
    jj_mask_76[PUBLIC] = true;
  }
  static boolean[] jj_mask_77 = new boolean[117];
  static {
    jj_mask_77[PRIVATE] =
    jj_mask_77[PROTECTED] =
    jj_mask_77[PUBLIC] = true;
  }
  static boolean[] jj_mask_78 = new boolean[117];
  static {
    jj_mask_78[THROWS] = true;
  }
  static boolean[] jj_mask_79 = new boolean[117];
  static {
    jj_mask_79[BOOLEAN] =
    jj_mask_79[BREAK] =
    jj_mask_79[BYTE] =
    jj_mask_79[CHAR] =
    jj_mask_79[CLASS] =
    jj_mask_79[CONTINUE] =
    jj_mask_79[DO] =
    jj_mask_79[DOUBLE] =
    jj_mask_79[FALSE] =
    jj_mask_79[FINAL] =
    jj_mask_79[FLOAT] =
    jj_mask_79[FOR] =
    jj_mask_79[IF] =
    jj_mask_79[INT] =
    jj_mask_79[LONG] =
    jj_mask_79[NEW] =
    jj_mask_79[NULL] =
    jj_mask_79[RETURN] =
    jj_mask_79[SHORT] =
    jj_mask_79[SUPER] =
    jj_mask_79[SWITCH] =
    jj_mask_79[SYNCHRONIZED] =
    jj_mask_79[THIS] =
    jj_mask_79[THROW] =
    jj_mask_79[TRUE] =
    jj_mask_79[TRY] =
    jj_mask_79[WHILE] =
    jj_mask_79[INTEGER_LITERAL] =
    jj_mask_79[FLOATING_POINT_LITERAL] =
    jj_mask_79[CHARACTER_LITERAL] =
    jj_mask_79[STRING_LITERAL] =
    jj_mask_79[IDENTIFIER] =
    jj_mask_79[LPAREN] =
    jj_mask_79[LBRACE] =
    jj_mask_79[SEMICOLON] =
    jj_mask_79[INCR] =
    jj_mask_79[DECR] = true;
  }
  
  final public void ExplicitConstructorInvocation() throws ParseError {
    if (jj_2_13(2147483647)) {
      jj_consume_token(THIS);
      Arguments();
      jj_consume_token(SEMICOLON);
    } else {
      if (jj_mask_80[getToken(1).kind]) {
        if (jj_2_12(2)) {
          PrimaryExpression();
          jj_consume_token(DOT);
        } else {
          ;
        }
        jj_consume_token(SUPER);
        Arguments();
        jj_consume_token(SEMICOLON);
      } else {
        jj_expLA1[80] = jj_gen;
        jj_consume_token(-1);
        throw new ParseError();
      }
    }
  }

  static boolean[] jj_mask_80 = new boolean[117];
  static {
    jj_mask_80[BOOLEAN] =
    jj_mask_80[BYTE] =
    jj_mask_80[CHAR] =
    jj_mask_80[DOUBLE] =
    jj_mask_80[FALSE] =
    jj_mask_80[FLOAT] =
    jj_mask_80[INT] =
    jj_mask_80[LONG] =
    jj_mask_80[NEW] =
    jj_mask_80[NULL] =
    jj_mask_80[SHORT] =
    jj_mask_80[SUPER] =
    jj_mask_80[THIS] =
    jj_mask_80[TRUE] =
    jj_mask_80[INTEGER_LITERAL] =
    jj_mask_80[FLOATING_POINT_LITERAL] =
    jj_mask_80[CHARACTER_LITERAL] =
    jj_mask_80[STRING_LITERAL] =
    jj_mask_80[IDENTIFIER] =
    jj_mask_80[LPAREN] = true;
  }
  
  final public void Initializer() throws ParseError {
    if (jj_mask_81[getToken(1).kind]) {
      jj_consume_token(STATIC);
    } else {
      jj_expLA1[81] = jj_gen;
      ;
    }
    Block();
  }

  static boolean[] jj_mask_81 = new boolean[117];
  static {
    jj_mask_81[STATIC] = true;
  }
  
/*
 * Type, name and expression syntax follows.
 */
  final public String Type(String context) throws ParseError {
 String name=null;
    if (jj_mask_83[getToken(1).kind]) {
      PrimitiveType();
    } else {
      jj_expLA1[83] = jj_gen;
      if (jj_mask_82[getToken(1).kind]) {
        name = Name();
                                  lno_=token.beginLine;
      } else {
        jj_expLA1[82] = jj_gen;
        jj_consume_token(-1);
        throw new ParseError();
      }
    }
    label_18:
    while (true) {
      if (jj_2_14(2)) {
        ;
      } else {
        break label_18;
      }
      jj_consume_token(LBRACKET);
      jj_consume_token(RBRACKET);
    }
                 BuildType(name, context);
          return name;
  }

  static boolean[] jj_mask_82 = new boolean[117];
  static {
    jj_mask_82[IDENTIFIER] = true;
  }
  static boolean[] jj_mask_83 = new boolean[117];
  static {
    jj_mask_83[BOOLEAN] =
    jj_mask_83[BYTE] =
    jj_mask_83[CHAR] =
    jj_mask_83[DOUBLE] =
    jj_mask_83[FLOAT] =
    jj_mask_83[INT] =
    jj_mask_83[LONG] =
    jj_mask_83[SHORT] = true;
  }
  
  final public void TypeList(String context) throws ParseError {
    Type(context);
    label_19:
    while (true) {
      if (jj_mask_84[getToken(1).kind]) {
        ;
      } else {
        jj_expLA1[84] = jj_gen;
        break label_19;
      }
      jj_consume_token(COMMA);
      Type(context);
    }
  }

  static boolean[] jj_mask_84 = new boolean[117];
  static {
    jj_mask_84[COMMA] = true;
  }
  
  final public void PrimitiveType() throws ParseError {
    if (jj_mask_92[getToken(1).kind]) {
      jj_consume_token(BOOLEAN);
    } else {
      jj_expLA1[92] = jj_gen;
      if (jj_mask_91[getToken(1).kind]) {
        jj_consume_token(CHAR);
      } else {
        jj_expLA1[91] = jj_gen;
        if (jj_mask_90[getToken(1).kind]) {
          jj_consume_token(BYTE);
        } else {
          jj_expLA1[90] = jj_gen;
          if (jj_mask_89[getToken(1).kind]) {
            jj_consume_token(SHORT);
          } else {
            jj_expLA1[89] = jj_gen;
            if (jj_mask_88[getToken(1).kind]) {
              jj_consume_token(INT);
            } else {
              jj_expLA1[88] = jj_gen;
              if (jj_mask_87[getToken(1).kind]) {
                jj_consume_token(LONG);
              } else {
                jj_expLA1[87] = jj_gen;
                if (jj_mask_86[getToken(1).kind]) {
                  jj_consume_token(FLOAT);
                } else {
                  jj_expLA1[86] = jj_gen;
                  if (jj_mask_85[getToken(1).kind]) {
                    jj_consume_token(DOUBLE);
                  } else {
                    jj_expLA1[85] = jj_gen;
                    jj_consume_token(-1);
                    throw new ParseError();
                  }
                }
              }
            }
          }
        }
      }
    }
  }

  static boolean[] jj_mask_85 = new boolean[117];
  static {
    jj_mask_85[DOUBLE] = true;
  }
  static boolean[] jj_mask_86 = new boolean[117];
  static {
    jj_mask_86[FLOAT] = true;
  }
  static boolean[] jj_mask_87 = new boolean[117];
  static {
    jj_mask_87[LONG] = true;
  }
  static boolean[] jj_mask_88 = new boolean[117];
  static {
    jj_mask_88[INT] = true;
  }
  static boolean[] jj_mask_89 = new boolean[117];
  static {
    jj_mask_89[SHORT] = true;
  }
  static boolean[] jj_mask_90 = new boolean[117];
  static {
    jj_mask_90[BYTE] = true;
  }
  static boolean[] jj_mask_91 = new boolean[117];
  static {
    jj_mask_91[CHAR] = true;
  }
  static boolean[] jj_mask_92 = new boolean[117];
  static {
    jj_mask_92[BOOLEAN] = true;
  }
  
  final public void ResultType() throws ParseError {
    if (jj_mask_94[getToken(1).kind]) {
      jj_consume_token(VOID);
    } else {
      jj_expLA1[94] = jj_gen;
      if (jj_mask_93[getToken(1).kind]) {
        Type("ResultType");
      } else {
        jj_expLA1[93] = jj_gen;
        jj_consume_token(-1);
        throw new ParseError();
      }
    }
  }

  static boolean[] jj_mask_93 = new boolean[117];
  static {
    jj_mask_93[BOOLEAN] =
    jj_mask_93[BYTE] =
    jj_mask_93[CHAR] =
    jj_mask_93[DOUBLE] =
    jj_mask_93[FLOAT] =
    jj_mask_93[INT] =
    jj_mask_93[LONG] =
    jj_mask_93[SHORT] =
    jj_mask_93[IDENTIFIER] = true;
  }
  static boolean[] jj_mask_94 = new boolean[117];
  static {
    jj_mask_94[VOID] = true;
  }
  
  final public String Name() throws ParseError {
 StrBuf sbuf = new StrBuf();
    jj_consume_token(IDENTIFIER);
                      sbuf.Assign(token.image);
    label_20:
    while (true) {
      if (jj_2_15(2)) {
        ;
      } else {
        break label_20;
      }
      jj_consume_token(DOT);
                     sbuf.Append(token.image);
      jj_consume_token(IDENTIFIER);
                              sbuf.Append(token.image);
    }
          return sbuf.toString();
  }

  final public void NameList() throws ParseError {
    Name();
    label_21:
    while (true) {
      if (jj_mask_95[getToken(1).kind]) {
        ;
      } else {
        jj_expLA1[95] = jj_gen;
        break label_21;
      }
      jj_consume_token(COMMA);
      Name();
    }
  }

  static boolean[] jj_mask_95 = new boolean[117];
  static {
    jj_mask_95[COMMA] = true;
  }
  
/*
 * Expression syntax follows.
 */
  final public void Expression() throws ParseError {
    if (jj_2_16(2147483647)) {
      Assignment();
    } else {
      if (jj_mask_96[getToken(1).kind]) {
        ConditionalExpression();
      } else {
        jj_expLA1[96] = jj_gen;
        jj_consume_token(-1);
        throw new ParseError();
      }
    }
  }

  static boolean[] jj_mask_96 = new boolean[117];
  static {
    jj_mask_96[BOOLEAN] =
    jj_mask_96[BYTE] =
    jj_mask_96[CHAR] =
    jj_mask_96[DOUBLE] =
    jj_mask_96[FALSE] =
    jj_mask_96[FLOAT] =
    jj_mask_96[INT] =
    jj_mask_96[LONG] =
    jj_mask_96[NEW] =
    jj_mask_96[NULL] =
    jj_mask_96[SHORT] =
    jj_mask_96[SUPER] =
    jj_mask_96[THIS] =
    jj_mask_96[TRUE] =
    jj_mask_96[INTEGER_LITERAL] =
    jj_mask_96[FLOATING_POINT_LITERAL] =
    jj_mask_96[CHARACTER_LITERAL] =
    jj_mask_96[STRING_LITERAL] =
    jj_mask_96[IDENTIFIER] =
    jj_mask_96[LPAREN] =
    jj_mask_96[BANG] =
    jj_mask_96[TILDE] =
    jj_mask_96[INCR] =
    jj_mask_96[DECR] =
    jj_mask_96[PLUS] =
    jj_mask_96[MINUS] = true;
  }
  
  final public void Assignment() throws ParseError {
    PrimaryExpression();
    AssignmentOperator();
    Expression();
  }

  final public void AssignmentOperator() throws ParseError {
    if (jj_mask_108[getToken(1).kind]) {
      jj_consume_token(ASSIGN);
    } else {
      jj_expLA1[108] = jj_gen;
      if (jj_mask_107[getToken(1).kind]) {
        jj_consume_token(STARASSIGN);
      } else {
        jj_expLA1[107] = jj_gen;
        if (jj_mask_106[getToken(1).kind]) {
          jj_consume_token(SLASHASSIGN);
        } else {
          jj_expLA1[106] = jj_gen;
          if (jj_mask_105[getToken(1).kind]) {
            jj_consume_token(REMASSIGN);
          } else {
            jj_expLA1[105] = jj_gen;
            if (jj_mask_104[getToken(1).kind]) {
              jj_consume_token(PLUSASSIGN);
            } else {
              jj_expLA1[104] = jj_gen;
              if (jj_mask_103[getToken(1).kind]) {
                jj_consume_token(MINUSASSIGN);
              } else {
                jj_expLA1[103] = jj_gen;
                if (jj_mask_102[getToken(1).kind]) {
                  jj_consume_token(LSHIFTASSIGN);
                } else {
                  jj_expLA1[102] = jj_gen;
                  if (jj_mask_101[getToken(1).kind]) {
                    jj_consume_token(RSIGNEDSHIFTASSIGN);
                  } else {
                    jj_expLA1[101] = jj_gen;
                    if (jj_mask_100[getToken(1).kind]) {
                      jj_consume_token(RUNSIGNEDSHIFTASSIGN);
                    } else {
                      jj_expLA1[100] = jj_gen;
                      if (jj_mask_99[getToken(1).kind]) {
                        jj_consume_token(ANDASSIGN);
                      } else {
                        jj_expLA1[99] = jj_gen;
                        if (jj_mask_98[getToken(1).kind]) {
                          jj_consume_token(XORASSIGN);
                        } else {
                          jj_expLA1[98] = jj_gen;
                          if (jj_mask_97[getToken(1).kind]) {
                            jj_consume_token(ORASSIGN);
                          } else {
                            jj_expLA1[97] = jj_gen;
                            jj_consume_token(-1);
                            throw new ParseError();
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        }
      }
    }
  }

  static boolean[] jj_mask_97 = new boolean[117];
  static {
    jj_mask_97[ORASSIGN] = true;
  }
  static boolean[] jj_mask_98 = new boolean[117];
  static {
    jj_mask_98[XORASSIGN] = true;
  }
  static boolean[] jj_mask_99 = new boolean[117];
  static {
    jj_mask_99[ANDASSIGN] = true;
  }
  static boolean[] jj_mask_100 = new boolean[117];
  static {
    jj_mask_100[RUNSIGNEDSHIFTASSIGN] = true;
  }
  static boolean[] jj_mask_101 = new boolean[117];
  static {
    jj_mask_101[RSIGNEDSHIFTASSIGN] = true;
  }
  static boolean[] jj_mask_102 = new boolean[117];
  static {
    jj_mask_102[LSHIFTASSIGN] = true;
  }
  static boolean[] jj_mask_103 = new boolean[117];
  static {
    jj_mask_103[MINUSASSIGN] = true;
  }
  static boolean[] jj_mask_104 = new boolean[117];
  static {
    jj_mask_104[PLUSASSIGN] = true;
  }
  static boolean[] jj_mask_105 = new boolean[117];
  static {
    jj_mask_105[REMASSIGN] = true;
  }
  static boolean[] jj_mask_106 = new boolean[117];
  static {
    jj_mask_106[SLASHASSIGN] = true;
  }
  static boolean[] jj_mask_107 = new boolean[117];
  static {
    jj_mask_107[STARASSIGN] = true;
  }
  static boolean[] jj_mask_108 = new boolean[117];
  static {
    jj_mask_108[ASSIGN] = true;
  }
  
  final public void ConditionalExpression() throws ParseError {
    ConditionalOrExpression();
    if (jj_mask_109[getToken(1).kind]) {
      jj_consume_token(HOOK);
      Expression();
      jj_consume_token(COLON);
      ConditionalExpression();
    } else {
      jj_expLA1[109] = jj_gen;
      ;
    }
  }

  static boolean[] jj_mask_109 = new boolean[117];
  static {
    jj_mask_109[HOOK] = true;
  }
  
  final public void ConditionalOrExpression() throws ParseError {
    ConditionalAndExpression();
    label_22:
    while (true) {
      if (jj_mask_110[getToken(1).kind]) {
        ;
      } else {
        jj_expLA1[110] = jj_gen;
        break label_22;
      }
      jj_consume_token(SC_OR);
      ConditionalAndExpression();
    }
  }

  static boolean[] jj_mask_110 = new boolean[117];
  static {
    jj_mask_110[SC_OR] = true;
  }
  
  final public void ConditionalAndExpression() throws ParseError {
    InclusiveOrExpression();
    label_23:
    while (true) {
      if (jj_mask_111[getToken(1).kind]) {
        ;
      } else {
        jj_expLA1[111] = jj_gen;
        break label_23;
      }
      jj_consume_token(SC_AND);
      InclusiveOrExpression();
    }
  }

  static boolean[] jj_mask_111 = new boolean[117];
  static {
    jj_mask_111[SC_AND] = true;
  }
  
  final public void InclusiveOrExpression() throws ParseError {
    ExclusiveOrExpression();
    label_24:
    while (true) {
      if (jj_mask_112[getToken(1).kind]) {
        ;
      } else {
        jj_expLA1[112] = jj_gen;
        break label_24;
      }
      jj_consume_token(BIT_OR);
      ExclusiveOrExpression();
    }
  }

  static boolean[] jj_mask_112 = new boolean[117];
  static {
    jj_mask_112[BIT_OR] = true;
  }
  
  final public void ExclusiveOrExpression() throws ParseError {
    AndExpression();
    label_25:
    while (true) {
      if (jj_mask_113[getToken(1).kind]) {
        ;
      } else {
        jj_expLA1[113] = jj_gen;
        break label_25;
      }
      jj_consume_token(XOR);
      AndExpression();
    }
  }

  static boolean[] jj_mask_113 = new boolean[117];
  static {
    jj_mask_113[XOR] = true;
  }
  
  final public void AndExpression() throws ParseError {
    EqualityExpression();
    label_26:
    while (true) {
      if (jj_mask_114[getToken(1).kind]) {
        ;
      } else {
        jj_expLA1[114] = jj_gen;
        break label_26;
      }
      jj_consume_token(BIT_AND);
      EqualityExpression();
    }
  }

  static boolean[] jj_mask_114 = new boolean[117];
  static {
    jj_mask_114[BIT_AND] = true;
  }
  
  final public void EqualityExpression() throws ParseError {
    InstanceOfExpression();
    label_27:
    while (true) {
      if (jj_mask_115[getToken(1).kind]) {
        ;
      } else {
        jj_expLA1[115] = jj_gen;
        break label_27;
      }
      if (jj_mask_117[getToken(1).kind]) {
        jj_consume_token(EQ);
      } else {
        jj_expLA1[117] = jj_gen;
        if (jj_mask_116[getToken(1).kind]) {
          jj_consume_token(NE);
        } else {
          jj_expLA1[116] = jj_gen;
          jj_consume_token(-1);
          throw new ParseError();
        }
      }
      InstanceOfExpression();
    }
  }

  static boolean[] jj_mask_115 = new boolean[117];
  static {
    jj_mask_115[EQ] =
    jj_mask_115[NE] = true;
  }
  static boolean[] jj_mask_116 = new boolean[117];
  static {
    jj_mask_116[NE] = true;
  }
  static boolean[] jj_mask_117 = new boolean[117];
  static {
    jj_mask_117[EQ] = true;
  }
  
  final public void InstanceOfExpression() throws ParseError {
    RelationalExpression();
    if (jj_mask_118[getToken(1).kind]) {
      jj_consume_token(INSTANCEOF);
      Type("InstanceOfExpression");
    } else {
      jj_expLA1[118] = jj_gen;
      ;
    }
  }

  static boolean[] jj_mask_118 = new boolean[117];
  static {
    jj_mask_118[INSTANCEOF] = true;
  }
  
  final public void RelationalExpression() throws ParseError {
    ShiftExpression();
    label_28:
    while (true) {
      if (jj_mask_119[getToken(1).kind]) {
        ;
      } else {
        jj_expLA1[119] = jj_gen;
        break label_28;
      }
      if (jj_mask_123[getToken(1).kind]) {
        jj_consume_token(LT);
      } else {
        jj_expLA1[123] = jj_gen;
        if (jj_mask_122[getToken(1).kind]) {
          jj_consume_token(GT);
        } else {
          jj_expLA1[122] = jj_gen;
          if (jj_mask_121[getToken(1).kind]) {
            jj_consume_token(LE);
          } else {
            jj_expLA1[121] = jj_gen;
            if (jj_mask_120[getToken(1).kind]) {
              jj_consume_token(GE);
            } else {
              jj_expLA1[120] = jj_gen;
              jj_consume_token(-1);
              throw new ParseError();
            }
          }
        }
      }
      ShiftExpression();
    }
  }

  static boolean[] jj_mask_119 = new boolean[117];
  static {
    jj_mask_119[GT] =
    jj_mask_119[LT] =
    jj_mask_119[LE] =
    jj_mask_119[GE] = true;
  }
  static boolean[] jj_mask_120 = new boolean[117];
  static {
    jj_mask_120[GE] = true;
  }
  static boolean[] jj_mask_121 = new boolean[117];
  static {
    jj_mask_121[LE] = true;
  }
  static boolean[] jj_mask_122 = new boolean[117];
  static {
    jj_mask_122[GT] = true;
  }
  static boolean[] jj_mask_123 = new boolean[117];
  static {
    jj_mask_123[LT] = true;
  }
  
  final public void ShiftExpression() throws ParseError {
    AdditiveExpression();
    label_29:
    while (true) {
      if (jj_mask_124[getToken(1).kind]) {
        ;
      } else {
        jj_expLA1[124] = jj_gen;
        break label_29;
      }
      if (jj_mask_127[getToken(1).kind]) {
        jj_consume_token(LSHIFT);
      } else {
        jj_expLA1[127] = jj_gen;
        if (jj_mask_126[getToken(1).kind]) {
          jj_consume_token(RSIGNEDSHIFT);
        } else {
          jj_expLA1[126] = jj_gen;
          if (jj_mask_125[getToken(1).kind]) {
            jj_consume_token(RUNSIGNEDSHIFT);
          } else {
            jj_expLA1[125] = jj_gen;
            jj_consume_token(-1);
            throw new ParseError();
          }
        }
      }
      AdditiveExpression();
    }
  }

  static boolean[] jj_mask_124 = new boolean[117];
  static {
    jj_mask_124[LSHIFT] =
    jj_mask_124[RSIGNEDSHIFT] =
    jj_mask_124[RUNSIGNEDSHIFT] = true;
  }
  static boolean[] jj_mask_125 = new boolean[117];
  static {
    jj_mask_125[RUNSIGNEDSHIFT] = true;
  }
  static boolean[] jj_mask_126 = new boolean[117];
  static {
    jj_mask_126[RSIGNEDSHIFT] = true;
  }
  static boolean[] jj_mask_127 = new boolean[117];
  static {
    jj_mask_127[LSHIFT] = true;
  }
  
  final public void AdditiveExpression() throws ParseError {
    MultiplicativeExpression();
    label_30:
    while (true) {
      if (jj_mask_128[getToken(1).kind]) {
        ;
      } else {
        jj_expLA1[128] = jj_gen;
        break label_30;
      }
      if (jj_mask_130[getToken(1).kind]) {
        jj_consume_token(PLUS);
      } else {
        jj_expLA1[130] = jj_gen;
        if (jj_mask_129[getToken(1).kind]) {
          jj_consume_token(MINUS);
        } else {
          jj_expLA1[129] = jj_gen;
          jj_consume_token(-1);
          throw new ParseError();
        }
      }
      MultiplicativeExpression();
    }
  }

  static boolean[] jj_mask_128 = new boolean[117];
  static {
    jj_mask_128[PLUS] =
    jj_mask_128[MINUS] = true;
  }
  static boolean[] jj_mask_129 = new boolean[117];
  static {
    jj_mask_129[MINUS] = true;
  }
  static boolean[] jj_mask_130 = new boolean[117];
  static {
    jj_mask_130[PLUS] = true;
  }
  
  final public void MultiplicativeExpression() throws ParseError {
    UnaryExpression();
    label_31:
    while (true) {
      if (jj_mask_131[getToken(1).kind]) {
        ;
      } else {
        jj_expLA1[131] = jj_gen;
        break label_31;
      }
      if (jj_mask_134[getToken(1).kind]) {
        jj_consume_token(STAR);
      } else {
        jj_expLA1[134] = jj_gen;
        if (jj_mask_133[getToken(1).kind]) {
          jj_consume_token(SLASH);
        } else {
          jj_expLA1[133] = jj_gen;
          if (jj_mask_132[getToken(1).kind]) {
            jj_consume_token(REM);
          } else {
            jj_expLA1[132] = jj_gen;
            jj_consume_token(-1);
            throw new ParseError();
          }
        }
      }
      UnaryExpression();
    }
  }

  static boolean[] jj_mask_131 = new boolean[117];
  static {
    jj_mask_131[STAR] =
    jj_mask_131[SLASH] =
    jj_mask_131[REM] = true;
  }
  static boolean[] jj_mask_132 = new boolean[117];
  static {
    jj_mask_132[REM] = true;
  }
  static boolean[] jj_mask_133 = new boolean[117];
  static {
    jj_mask_133[SLASH] = true;
  }
  static boolean[] jj_mask_134 = new boolean[117];
  static {
    jj_mask_134[STAR] = true;
  }
  
  final public void UnaryExpression() throws ParseError {
    if (jj_mask_140[getToken(1).kind]) {
      if (jj_mask_139[getToken(1).kind]) {
        jj_consume_token(PLUS);
      } else {
        jj_expLA1[139] = jj_gen;
        if (jj_mask_138[getToken(1).kind]) {
          jj_consume_token(MINUS);
        } else {
          jj_expLA1[138] = jj_gen;
          jj_consume_token(-1);
          throw new ParseError();
        }
      }
      UnaryExpression();
    } else {
      jj_expLA1[140] = jj_gen;
      if (jj_mask_137[getToken(1).kind]) {
        PreIncrementExpression();
      } else {
        jj_expLA1[137] = jj_gen;
        if (jj_mask_136[getToken(1).kind]) {
          PreDecrementExpression();
        } else {
          jj_expLA1[136] = jj_gen;
          if (jj_mask_135[getToken(1).kind]) {
            UnaryExpressionNotPlusMinus();
          } else {
            jj_expLA1[135] = jj_gen;
            jj_consume_token(-1);
            throw new ParseError();
          }
        }
      }
    }
  }

  static boolean[] jj_mask_135 = new boolean[117];
  static {
    jj_mask_135[BOOLEAN] =
    jj_mask_135[BYTE] =
    jj_mask_135[CHAR] =
    jj_mask_135[DOUBLE] =
    jj_mask_135[FALSE] =
    jj_mask_135[FLOAT] =
    jj_mask_135[INT] =
    jj_mask_135[LONG] =
    jj_mask_135[NEW] =
    jj_mask_135[NULL] =
    jj_mask_135[SHORT] =
    jj_mask_135[SUPER] =
    jj_mask_135[THIS] =
    jj_mask_135[TRUE] =
    jj_mask_135[INTEGER_LITERAL] =
    jj_mask_135[FLOATING_POINT_LITERAL] =
    jj_mask_135[CHARACTER_LITERAL] =
    jj_mask_135[STRING_LITERAL] =
    jj_mask_135[IDENTIFIER] =
    jj_mask_135[LPAREN] =
    jj_mask_135[BANG] =
    jj_mask_135[TILDE] = true;
  }
  static boolean[] jj_mask_136 = new boolean[117];
  static {
    jj_mask_136[DECR] = true;
  }
  static boolean[] jj_mask_137 = new boolean[117];
  static {
    jj_mask_137[INCR] = true;
  }
  static boolean[] jj_mask_138 = new boolean[117];
  static {
    jj_mask_138[MINUS] = true;
  }
  static boolean[] jj_mask_139 = new boolean[117];
  static {
    jj_mask_139[PLUS] = true;
  }
  static boolean[] jj_mask_140 = new boolean[117];
  static {
    jj_mask_140[PLUS] =
    jj_mask_140[MINUS] = true;
  }
  
  final public void PreIncrementExpression() throws ParseError {
    jj_consume_token(INCR);
    PrimaryExpression();
  }

  final public void PreDecrementExpression() throws ParseError {
    jj_consume_token(DECR);
    PrimaryExpression();
  }

  final public void UnaryExpressionNotPlusMinus() throws ParseError {
    if (jj_mask_144[getToken(1).kind]) {
      if (jj_mask_143[getToken(1).kind]) {
        jj_consume_token(TILDE);
      } else {
        jj_expLA1[143] = jj_gen;
        if (jj_mask_142[getToken(1).kind]) {
          jj_consume_token(BANG);
        } else {
          jj_expLA1[142] = jj_gen;
          jj_consume_token(-1);
          throw new ParseError();
        }
      }
      UnaryExpression();
    } else {
      jj_expLA1[144] = jj_gen;
      if (jj_2_17(2147483647)) {
        CastExpression();
      } else {
        if (jj_mask_141[getToken(1).kind]) {
          PostfixExpression();
        } else {
          jj_expLA1[141] = jj_gen;
          jj_consume_token(-1);
          throw new ParseError();
        }
      }
    }
  }

  static boolean[] jj_mask_141 = new boolean[117];
  static {
    jj_mask_141[BOOLEAN] =
    jj_mask_141[BYTE] =
    jj_mask_141[CHAR] =
    jj_mask_141[DOUBLE] =
    jj_mask_141[FALSE] =
    jj_mask_141[FLOAT] =
    jj_mask_141[INT] =
    jj_mask_141[LONG] =
    jj_mask_141[NEW] =
    jj_mask_141[NULL] =
    jj_mask_141[SHORT] =
    jj_mask_141[SUPER] =
    jj_mask_141[THIS] =
    jj_mask_141[TRUE] =
    jj_mask_141[INTEGER_LITERAL] =
    jj_mask_141[FLOATING_POINT_LITERAL] =
    jj_mask_141[CHARACTER_LITERAL] =
    jj_mask_141[STRING_LITERAL] =
    jj_mask_141[IDENTIFIER] =
    jj_mask_141[LPAREN] = true;
  }
  static boolean[] jj_mask_142 = new boolean[117];
  static {
    jj_mask_142[BANG] = true;
  }
  static boolean[] jj_mask_143 = new boolean[117];
  static {
    jj_mask_143[TILDE] = true;
  }
  static boolean[] jj_mask_144 = new boolean[117];
  static {
    jj_mask_144[BANG] =
    jj_mask_144[TILDE] = true;
  }
  
// This production is to determine lookahead only.  The LOOKAHEAD specifications
// below are not used, but they are there just to indicate that we know about
// this.
  final public void CastLookahead() throws ParseError {
    if (jj_2_19(2)) {
      jj_consume_token(LPAREN);
      PrimitiveType();
    } else {
      if (jj_2_18(2147483647)) {
        jj_consume_token(LPAREN);
        Type("CastLookahead");
        jj_consume_token(LBRACKET);
        jj_consume_token(RBRACKET);
      } else {
        if (jj_mask_153[getToken(1).kind]) {
          jj_consume_token(LPAREN);
          Type("CastLookahead");
          jj_consume_token(RPAREN);
          if (jj_mask_152[getToken(1).kind]) {
            jj_consume_token(TILDE);
          } else {
            jj_expLA1[152] = jj_gen;
            if (jj_mask_151[getToken(1).kind]) {
              jj_consume_token(BANG);
            } else {
              jj_expLA1[151] = jj_gen;
              if (jj_mask_150[getToken(1).kind]) {
                jj_consume_token(LPAREN);
              } else {
                jj_expLA1[150] = jj_gen;
                if (jj_mask_149[getToken(1).kind]) {
                  jj_consume_token(IDENTIFIER);
                } else {
                  jj_expLA1[149] = jj_gen;
                  if (jj_mask_148[getToken(1).kind]) {
                    jj_consume_token(THIS);
                  } else {
                    jj_expLA1[148] = jj_gen;
                    if (jj_mask_147[getToken(1).kind]) {
                      jj_consume_token(SUPER);
                    } else {
                      jj_expLA1[147] = jj_gen;
                      if (jj_mask_146[getToken(1).kind]) {
                        jj_consume_token(NEW);
                      } else {
                        jj_expLA1[146] = jj_gen;
                        if (jj_mask_145[getToken(1).kind]) {
                          Literal();
                        } else {
                          jj_expLA1[145] = jj_gen;
                          jj_consume_token(-1);
                          throw new ParseError();
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        } else {
          jj_expLA1[153] = jj_gen;
          jj_consume_token(-1);
          throw new ParseError();
        }
      }
    }
  }

  static boolean[] jj_mask_145 = new boolean[117];
  static {
    jj_mask_145[FALSE] =
    jj_mask_145[NULL] =
    jj_mask_145[TRUE] =
    jj_mask_145[INTEGER_LITERAL] =
    jj_mask_145[FLOATING_POINT_LITERAL] =
    jj_mask_145[CHARACTER_LITERAL] =
    jj_mask_145[STRING_LITERAL] = true;
  }
  static boolean[] jj_mask_146 = new boolean[117];
  static {
    jj_mask_146[NEW] = true;
  }
  static boolean[] jj_mask_147 = new boolean[117];
  static {
    jj_mask_147[SUPER] = true;
  }
  static boolean[] jj_mask_148 = new boolean[117];
  static {
    jj_mask_148[THIS] = true;
  }
  static boolean[] jj_mask_149 = new boolean[117];
  static {
    jj_mask_149[IDENTIFIER] = true;
  }
  static boolean[] jj_mask_150 = new boolean[117];
  static {
    jj_mask_150[LPAREN] = true;
  }
  static boolean[] jj_mask_151 = new boolean[117];
  static {
    jj_mask_151[BANG] = true;
  }
  static boolean[] jj_mask_152 = new boolean[117];
  static {
    jj_mask_152[TILDE] = true;
  }
  static boolean[] jj_mask_153 = new boolean[117];
  static {
    jj_mask_153[LPAREN] = true;
  }
  
  final public void PostfixExpression() throws ParseError {
    PrimaryExpression();
    if (jj_mask_156[getToken(1).kind]) {
      if (jj_mask_155[getToken(1).kind]) {
        jj_consume_token(INCR);
      } else {
        jj_expLA1[155] = jj_gen;
        if (jj_mask_154[getToken(1).kind]) {
          jj_consume_token(DECR);
        } else {
          jj_expLA1[154] = jj_gen;
          jj_consume_token(-1);
          throw new ParseError();
        }
      }
    } else {
      jj_expLA1[156] = jj_gen;
      ;
    }
  }

  static boolean[] jj_mask_154 = new boolean[117];
  static {
    jj_mask_154[DECR] = true;
  }
  static boolean[] jj_mask_155 = new boolean[117];
  static {
    jj_mask_155[INCR] = true;
  }
  static boolean[] jj_mask_156 = new boolean[117];
  static {
    jj_mask_156[INCR] =
    jj_mask_156[DECR] = true;
  }
  
  final public void CastExpression() throws ParseError {
    if (jj_2_21(2147483647)) {
      jj_consume_token(LPAREN);
      Type("CastExpression");
      jj_consume_token(RPAREN);
      UnaryExpression();
    } else {
      if (jj_2_20(2147483647)) {
        jj_consume_token(LPAREN);
        Type("CastExpression");
        jj_consume_token(RPAREN);
        UnaryExpressionNotPlusMinus();
      } else {
        jj_consume_token(-1);
        throw new ParseError();
      }
    }
  }

  final public void PrimaryExpression() throws ParseError {
    PrimaryPrefix();
    label_32:
    while (true) {
      if (jj_2_22(2)) {
        ;
      } else {
        break label_32;
      }
      PrimarySuffix();
    }
  }

  final public void PrimaryPrefix() throws ParseError {
    if (jj_mask_162[getToken(1).kind]) {
      Literal();
    } else {
      jj_expLA1[162] = jj_gen;
      if (jj_mask_161[getToken(1).kind]) {
        Type("PrimaryPrefix");
      } else {
        jj_expLA1[161] = jj_gen;
        if (jj_mask_160[getToken(1).kind]) {
          jj_consume_token(THIS);
        } else {
          jj_expLA1[160] = jj_gen;
          if (jj_mask_159[getToken(1).kind]) {
            jj_consume_token(SUPER);
            jj_consume_token(DOT);
            jj_consume_token(IDENTIFIER);
          } else {
            jj_expLA1[159] = jj_gen;
            if (jj_mask_158[getToken(1).kind]) {
              jj_consume_token(LPAREN);
              Expression();
              jj_consume_token(RPAREN);
            } else {
              jj_expLA1[158] = jj_gen;
              if (jj_mask_157[getToken(1).kind]) {
                AllocationExpression();
              } else {
                jj_expLA1[157] = jj_gen;
                jj_consume_token(-1);
                throw new ParseError();
              }
            }
          }
        }
      }
    }
  }

  static boolean[] jj_mask_157 = new boolean[117];
  static {
    jj_mask_157[NEW] = true;
  }
  static boolean[] jj_mask_158 = new boolean[117];
  static {
    jj_mask_158[LPAREN] = true;
  }
  static boolean[] jj_mask_159 = new boolean[117];
  static {
    jj_mask_159[SUPER] = true;
  }
  static boolean[] jj_mask_160 = new boolean[117];
  static {
    jj_mask_160[THIS] = true;
  }
  static boolean[] jj_mask_161 = new boolean[117];
  static {
    jj_mask_161[BOOLEAN] =
    jj_mask_161[BYTE] =
    jj_mask_161[CHAR] =
    jj_mask_161[DOUBLE] =
    jj_mask_161[FLOAT] =
    jj_mask_161[INT] =
    jj_mask_161[LONG] =
    jj_mask_161[SHORT] =
    jj_mask_161[IDENTIFIER] = true;
  }
  static boolean[] jj_mask_162 = new boolean[117];
  static {
    jj_mask_162[FALSE] =
    jj_mask_162[NULL] =
    jj_mask_162[TRUE] =
    jj_mask_162[INTEGER_LITERAL] =
    jj_mask_162[FLOATING_POINT_LITERAL] =
    jj_mask_162[CHARACTER_LITERAL] =
    jj_mask_162[STRING_LITERAL] = true;
  }
  
  final public void PrimarySuffix() throws ParseError {
    if (jj_2_25(2)) {
      jj_consume_token(DOT);
      jj_consume_token(THIS);
    } else {
      if (jj_2_24(2)) {
        jj_consume_token(DOT);
        jj_consume_token(CLASS);
      } else {
        if (jj_2_23(2)) {
          jj_consume_token(DOT);
          AllocationExpression();
        } else {
          if (jj_mask_165[getToken(1).kind]) {
            jj_consume_token(LBRACKET);
            Expression();
            jj_consume_token(RBRACKET);
          } else {
            jj_expLA1[165] = jj_gen;
            if (jj_mask_164[getToken(1).kind]) {
              jj_consume_token(DOT);
              jj_consume_token(IDENTIFIER);
            } else {
              jj_expLA1[164] = jj_gen;
              if (jj_mask_163[getToken(1).kind]) {
                Arguments();
              } else {
                jj_expLA1[163] = jj_gen;
                jj_consume_token(-1);
                throw new ParseError();
              }
            }
          }
        }
      }
    }
  }

  static boolean[] jj_mask_163 = new boolean[117];
  static {
    jj_mask_163[LPAREN] = true;
  }
  static boolean[] jj_mask_164 = new boolean[117];
  static {
    jj_mask_164[DOT] = true;
  }
  static boolean[] jj_mask_165 = new boolean[117];
  static {
    jj_mask_165[LBRACKET] = true;
  }
  
  final public void Literal() throws ParseError {
    if (jj_mask_171[getToken(1).kind]) {
      jj_consume_token(INTEGER_LITERAL);
    } else {
      jj_expLA1[171] = jj_gen;
      if (jj_mask_170[getToken(1).kind]) {
        jj_consume_token(FLOATING_POINT_LITERAL);
      } else {
        jj_expLA1[170] = jj_gen;
        if (jj_mask_169[getToken(1).kind]) {
          jj_consume_token(CHARACTER_LITERAL);
        } else {
          jj_expLA1[169] = jj_gen;
          if (jj_mask_168[getToken(1).kind]) {
            jj_consume_token(STRING_LITERAL);
          } else {
            jj_expLA1[168] = jj_gen;
            if (jj_mask_167[getToken(1).kind]) {
              BooleanLiteral();
            } else {
              jj_expLA1[167] = jj_gen;
              if (jj_mask_166[getToken(1).kind]) {
                NullLiteral();
              } else {
                jj_expLA1[166] = jj_gen;
                jj_consume_token(-1);
                throw new ParseError();
              }
            }
          }
        }
      }
    }
  }

  static boolean[] jj_mask_166 = new boolean[117];
  static {
    jj_mask_166[NULL] = true;
  }
  static boolean[] jj_mask_167 = new boolean[117];
  static {
    jj_mask_167[FALSE] =
    jj_mask_167[TRUE] = true;
  }
  static boolean[] jj_mask_168 = new boolean[117];
  static {
    jj_mask_168[STRING_LITERAL] = true;
  }
  static boolean[] jj_mask_169 = new boolean[117];
  static {
    jj_mask_169[CHARACTER_LITERAL] = true;
  }
  static boolean[] jj_mask_170 = new boolean[117];
  static {
    jj_mask_170[FLOATING_POINT_LITERAL] = true;
  }
  static boolean[] jj_mask_171 = new boolean[117];
  static {
    jj_mask_171[INTEGER_LITERAL] = true;
  }
  
  final public void BooleanLiteral() throws ParseError {
    if (jj_mask_173[getToken(1).kind]) {
      jj_consume_token(TRUE);
    } else {
      jj_expLA1[173] = jj_gen;
      if (jj_mask_172[getToken(1).kind]) {
        jj_consume_token(FALSE);
      } else {
        jj_expLA1[172] = jj_gen;
        jj_consume_token(-1);
        throw new ParseError();
      }
    }
  }

  static boolean[] jj_mask_172 = new boolean[117];
  static {
    jj_mask_172[FALSE] = true;
  }
  static boolean[] jj_mask_173 = new boolean[117];
  static {
    jj_mask_173[TRUE] = true;
  }
  
  final public void NullLiteral() throws ParseError {
    jj_consume_token(NULL);
  }

  final public void Arguments() throws ParseError {
    jj_consume_token(LPAREN);
    if (jj_mask_174[getToken(1).kind]) {
      ArgumentList();
    } else {
      jj_expLA1[174] = jj_gen;
      ;
    }
    jj_consume_token(RPAREN);
  }

  static boolean[] jj_mask_174 = new boolean[117];
  static {
    jj_mask_174[BOOLEAN] =
    jj_mask_174[BYTE] =
    jj_mask_174[CHAR] =
    jj_mask_174[DOUBLE] =
    jj_mask_174[FALSE] =
    jj_mask_174[FLOAT] =
    jj_mask_174[INT] =
    jj_mask_174[LONG] =
    jj_mask_174[NEW] =
    jj_mask_174[NULL] =
    jj_mask_174[SHORT] =
    jj_mask_174[SUPER] =
    jj_mask_174[THIS] =
    jj_mask_174[TRUE] =
    jj_mask_174[INTEGER_LITERAL] =
    jj_mask_174[FLOATING_POINT_LITERAL] =
    jj_mask_174[CHARACTER_LITERAL] =
    jj_mask_174[STRING_LITERAL] =
    jj_mask_174[IDENTIFIER] =
    jj_mask_174[LPAREN] =
    jj_mask_174[BANG] =
    jj_mask_174[TILDE] =
    jj_mask_174[INCR] =
    jj_mask_174[DECR] =
    jj_mask_174[PLUS] =
    jj_mask_174[MINUS] = true;
  }
  
  final public void ArgumentList() throws ParseError {
    Expression();
    label_33:
    while (true) {
      if (jj_mask_175[getToken(1).kind]) {
        ;
      } else {
        jj_expLA1[175] = jj_gen;
        break label_33;
      }
      jj_consume_token(COMMA);
      Expression();
    }
  }

  static boolean[] jj_mask_175 = new boolean[117];
  static {
    jj_mask_175[COMMA] = true;
  }
  
  final public void AllocationExpression() throws ParseError {
 String name=null;
    if (jj_2_27(2)) {
      jj_consume_token(NEW);
      PrimitiveType();
      ArrayDimensions();
      if (jj_mask_180[getToken(1).kind]) {
        ArrayInitializer();
      } else {
        jj_expLA1[180] = jj_gen;
        ;
      }
    } else {
      if (jj_mask_179[getToken(1).kind]) {
        jj_consume_token(NEW);
        name = Type("AllocationExpression");
        if (jj_mask_178[getToken(1).kind]) {
          ArrayDimensions();
          if (jj_mask_177[getToken(1).kind]) {
            ArrayInitializer();
          } else {
            jj_expLA1[177] = jj_gen;
            ;
          }
        } else {
          jj_expLA1[178] = jj_gen;
          if (jj_mask_176[getToken(1).kind]) {
            Arguments();
            if (jj_2_26(2147483647)) {
                         xtnds_ = name;
                         if(prev_anon_ != null && prev_anon_.equals(class_name_))
                         {
                                 anon_cnt_++;
                         }
                         else
                         {
                                 prev_anon_ = class_name_;
                                 anon_cnt_ = 1;
                         }

                         BuildTgt(class_name_+"$"+anon_cnt_, "AnonymousClassDeclaration");
              ClassBody();
            } else {
              ;
            }
          } else {
            jj_expLA1[176] = jj_gen;
            jj_consume_token(-1);
            throw new ParseError();
          }
        }
      } else {
        jj_expLA1[179] = jj_gen;
        jj_consume_token(-1);
        throw new ParseError();
      }
    }
  }

  static boolean[] jj_mask_176 = new boolean[117];
  static {
    jj_mask_176[LPAREN] = true;
  }
  static boolean[] jj_mask_177 = new boolean[117];
  static {
    jj_mask_177[LBRACE] = true;
  }
  static boolean[] jj_mask_178 = new boolean[117];
  static {
    jj_mask_178[LBRACKET] = true;
  }
  static boolean[] jj_mask_179 = new boolean[117];
  static {
    jj_mask_179[NEW] = true;
  }
  static boolean[] jj_mask_180 = new boolean[117];
  static {
    jj_mask_180[LBRACE] = true;
  }
  
/*
 * The second LOOKAHEAD specification below is to parse to PrimarySuffix
 * if there is an expression between the "[...]".
 */
  final public void ArrayDimensions() throws ParseError {
    label_34:
    while (true) {
      jj_consume_token(LBRACKET);
      Expression();
      jj_consume_token(RBRACKET);
      if (jj_2_28(2)) {
        ;
      } else {
        break label_34;
      }
    }
    label_35:
    while (true) {
      if (jj_2_29(2)) {
        ;
      } else {
        break label_35;
      }
      jj_consume_token(LBRACKET);
      jj_consume_token(RBRACKET);
    }
  }

/*
 * Statement syntax follows.
 */
  final public void Statement() throws ParseError {
    if (jj_2_30(2)) {
      LabeledStatement();
    } else {
      if (jj_mask_194[getToken(1).kind]) {
        Block();
      } else {
        jj_expLA1[194] = jj_gen;
        if (jj_mask_193[getToken(1).kind]) {
          EmptyStatement();
        } else {
          jj_expLA1[193] = jj_gen;
          if (jj_mask_192[getToken(1).kind]) {
            StatementExpression();
            jj_consume_token(SEMICOLON);
          } else {
            jj_expLA1[192] = jj_gen;
            if (jj_mask_191[getToken(1).kind]) {
              SwitchStatement();
            } else {
              jj_expLA1[191] = jj_gen;
              if (jj_mask_190[getToken(1).kind]) {
                IfStatement();
              } else {
                jj_expLA1[190] = jj_gen;
                if (jj_mask_189[getToken(1).kind]) {
                  WhileStatement();
                } else {
                  jj_expLA1[189] = jj_gen;
                  if (jj_mask_188[getToken(1).kind]) {
                    DoStatement();
                  } else {
                    jj_expLA1[188] = jj_gen;
                    if (jj_mask_187[getToken(1).kind]) {
                      ForStatement();
                    } else {
                      jj_expLA1[187] = jj_gen;
                      if (jj_mask_186[getToken(1).kind]) {
                        BreakStatement();
                      } else {
                        jj_expLA1[186] = jj_gen;
                        if (jj_mask_185[getToken(1).kind]) {
                          ContinueStatement();
                        } else {
                          jj_expLA1[185] = jj_gen;
                          if (jj_mask_184[getToken(1).kind]) {
                            ReturnStatement();
                          } else {
                            jj_expLA1[184] = jj_gen;
                            if (jj_mask_183[getToken(1).kind]) {
                              ThrowStatement();
                            } else {
                              jj_expLA1[183] = jj_gen;
                              if (jj_mask_182[getToken(1).kind]) {
                                SynchronizedStatement();
                              } else {
                                jj_expLA1[182] = jj_gen;
                                if (jj_mask_181[getToken(1).kind]) {
                                  TryStatement();
                                } else {
                                  jj_expLA1[181] = jj_gen;
                                  jj_consume_token(-1);
                                  throw new ParseError();
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        }
      }
    }
  }

  static boolean[] jj_mask_181 = new boolean[117];
  static {
    jj_mask_181[TRY] = true;
  }
  static boolean[] jj_mask_182 = new boolean[117];
  static {
    jj_mask_182[SYNCHRONIZED] = true;
  }
  static boolean[] jj_mask_183 = new boolean[117];
  static {
    jj_mask_183[THROW] = true;
  }
  static boolean[] jj_mask_184 = new boolean[117];
  static {
    jj_mask_184[RETURN] = true;
  }
  static boolean[] jj_mask_185 = new boolean[117];
  static {
    jj_mask_185[CONTINUE] = true;
  }
  static boolean[] jj_mask_186 = new boolean[117];
  static {
    jj_mask_186[BREAK] = true;
  }
  static boolean[] jj_mask_187 = new boolean[117];
  static {
    jj_mask_187[FOR] = true;
  }
  static boolean[] jj_mask_188 = new boolean[117];
  static {
    jj_mask_188[DO] = true;
  }
  static boolean[] jj_mask_189 = new boolean[117];
  static {
    jj_mask_189[WHILE] = true;
  }
  static boolean[] jj_mask_190 = new boolean[117];
  static {
    jj_mask_190[IF] = true;
  }
  static boolean[] jj_mask_191 = new boolean[117];
  static {
    jj_mask_191[SWITCH] = true;
  }
  static boolean[] jj_mask_192 = new boolean[117];
  static {
    jj_mask_192[BOOLEAN] =
    jj_mask_192[BYTE] =
    jj_mask_192[CHAR] =
    jj_mask_192[DOUBLE] =
    jj_mask_192[FALSE] =
    jj_mask_192[FLOAT] =
    jj_mask_192[INT] =
    jj_mask_192[LONG] =
    jj_mask_192[NEW] =
    jj_mask_192[NULL] =
    jj_mask_192[SHORT] =
    jj_mask_192[SUPER] =
    jj_mask_192[THIS] =
    jj_mask_192[TRUE] =
    jj_mask_192[INTEGER_LITERAL] =
    jj_mask_192[FLOATING_POINT_LITERAL] =
    jj_mask_192[CHARACTER_LITERAL] =
    jj_mask_192[STRING_LITERAL] =
    jj_mask_192[IDENTIFIER] =
    jj_mask_192[LPAREN] =
    jj_mask_192[INCR] =
    jj_mask_192[DECR] = true;
  }
  static boolean[] jj_mask_193 = new boolean[117];
  static {
    jj_mask_193[SEMICOLON] = true;
  }
  static boolean[] jj_mask_194 = new boolean[117];
  static {
    jj_mask_194[LBRACE] = true;
  }
  
  final public void LabeledStatement() throws ParseError {
    jj_consume_token(IDENTIFIER);
    jj_consume_token(COLON);
    Statement();
  }

  final public void Block() throws ParseError {
    jj_consume_token(LBRACE);
    label_36:
    while (true) {
      if (jj_mask_195[getToken(1).kind]) {
        ;
      } else {
        jj_expLA1[195] = jj_gen;
        break label_36;
      }
      BlockStatement();
    }
    jj_consume_token(RBRACE);
  }

  static boolean[] jj_mask_195 = new boolean[117];
  static {
    jj_mask_195[BOOLEAN] =
    jj_mask_195[BREAK] =
    jj_mask_195[BYTE] =
    jj_mask_195[CHAR] =
    jj_mask_195[CLASS] =
    jj_mask_195[CONTINUE] =
    jj_mask_195[DO] =
    jj_mask_195[DOUBLE] =
    jj_mask_195[FALSE] =
    jj_mask_195[FINAL] =
    jj_mask_195[FLOAT] =
    jj_mask_195[FOR] =
    jj_mask_195[IF] =
    jj_mask_195[INT] =
    jj_mask_195[LONG] =
    jj_mask_195[NEW] =
    jj_mask_195[NULL] =
    jj_mask_195[RETURN] =
    jj_mask_195[SHORT] =
    jj_mask_195[SUPER] =
    jj_mask_195[SWITCH] =
    jj_mask_195[SYNCHRONIZED] =
    jj_mask_195[THIS] =
    jj_mask_195[THROW] =
    jj_mask_195[TRUE] =
    jj_mask_195[TRY] =
    jj_mask_195[WHILE] =
    jj_mask_195[INTEGER_LITERAL] =
    jj_mask_195[FLOATING_POINT_LITERAL] =
    jj_mask_195[CHARACTER_LITERAL] =
    jj_mask_195[STRING_LITERAL] =
    jj_mask_195[IDENTIFIER] =
    jj_mask_195[LPAREN] =
    jj_mask_195[LBRACE] =
    jj_mask_195[SEMICOLON] =
    jj_mask_195[INCR] =
    jj_mask_195[DECR] = true;
  }
  
  final public void BlockStatement() throws ParseError {
    if (jj_2_31(2147483647)) {
      LocalVariableDeclaration();
      jj_consume_token(SEMICOLON);
    } else {
      if (jj_mask_197[getToken(1).kind]) {
        Statement();
      } else {
        jj_expLA1[197] = jj_gen;
        if (jj_mask_196[getToken(1).kind]) {
          UnmodifiedClassDeclaration("BlockStatement");
        } else {
          jj_expLA1[196] = jj_gen;
          jj_consume_token(-1);
          throw new ParseError();
        }
      }
    }
  }

  static boolean[] jj_mask_196 = new boolean[117];
  static {
    jj_mask_196[CLASS] = true;
  }
  static boolean[] jj_mask_197 = new boolean[117];
  static {
    jj_mask_197[BOOLEAN] =
    jj_mask_197[BREAK] =
    jj_mask_197[BYTE] =
    jj_mask_197[CHAR] =
    jj_mask_197[CONTINUE] =
    jj_mask_197[DO] =
    jj_mask_197[DOUBLE] =
    jj_mask_197[FALSE] =
    jj_mask_197[FLOAT] =
    jj_mask_197[FOR] =
    jj_mask_197[IF] =
    jj_mask_197[INT] =
    jj_mask_197[LONG] =
    jj_mask_197[NEW] =
    jj_mask_197[NULL] =
    jj_mask_197[RETURN] =
    jj_mask_197[SHORT] =
    jj_mask_197[SUPER] =
    jj_mask_197[SWITCH] =
    jj_mask_197[SYNCHRONIZED] =
    jj_mask_197[THIS] =
    jj_mask_197[THROW] =
    jj_mask_197[TRUE] =
    jj_mask_197[TRY] =
    jj_mask_197[WHILE] =
    jj_mask_197[INTEGER_LITERAL] =
    jj_mask_197[FLOATING_POINT_LITERAL] =
    jj_mask_197[CHARACTER_LITERAL] =
    jj_mask_197[STRING_LITERAL] =
    jj_mask_197[IDENTIFIER] =
    jj_mask_197[LPAREN] =
    jj_mask_197[LBRACE] =
    jj_mask_197[SEMICOLON] =
    jj_mask_197[INCR] =
    jj_mask_197[DECR] = true;
  }
  
  final public void LocalVariableDeclaration() throws ParseError {
    if (jj_mask_198[getToken(1).kind]) {
      jj_consume_token(FINAL);
    } else {
      jj_expLA1[198] = jj_gen;
      ;
    }
    Type("LocalVariableDeclaration");
    VariableDeclarator();
    label_37:
    while (true) {
      if (jj_mask_199[getToken(1).kind]) {
        ;
      } else {
        jj_expLA1[199] = jj_gen;
        break label_37;
      }
      jj_consume_token(COMMA);
      VariableDeclarator();
    }
  }

  static boolean[] jj_mask_198 = new boolean[117];
  static {
    jj_mask_198[FINAL] = true;
  }
  static boolean[] jj_mask_199 = new boolean[117];
  static {
    jj_mask_199[COMMA] = true;
  }
  
  final public void EmptyStatement() throws ParseError {
    jj_consume_token(SEMICOLON);
  }

  final public void StatementExpression() throws ParseError {
    if (jj_mask_202[getToken(1).kind]) {
      PreIncrementExpression();
    } else {
      jj_expLA1[202] = jj_gen;
      if (jj_mask_201[getToken(1).kind]) {
        PreDecrementExpression();
      } else {
        jj_expLA1[201] = jj_gen;
        if (jj_2_32(2147483647)) {
          Assignment();
        } else {
          if (jj_mask_200[getToken(1).kind]) {
            PostfixExpression();
          } else {
            jj_expLA1[200] = jj_gen;
            jj_consume_token(-1);
            throw new ParseError();
          }
        }
      }
    }
  }

  static boolean[] jj_mask_200 = new boolean[117];
  static {
    jj_mask_200[BOOLEAN] =
    jj_mask_200[BYTE] =
    jj_mask_200[CHAR] =
    jj_mask_200[DOUBLE] =
    jj_mask_200[FALSE] =
    jj_mask_200[FLOAT] =
    jj_mask_200[INT] =
    jj_mask_200[LONG] =
    jj_mask_200[NEW] =
    jj_mask_200[NULL] =
    jj_mask_200[SHORT] =
    jj_mask_200[SUPER] =
    jj_mask_200[THIS] =
    jj_mask_200[TRUE] =
    jj_mask_200[INTEGER_LITERAL] =
    jj_mask_200[FLOATING_POINT_LITERAL] =
    jj_mask_200[CHARACTER_LITERAL] =
    jj_mask_200[STRING_LITERAL] =
    jj_mask_200[IDENTIFIER] =
    jj_mask_200[LPAREN] = true;
  }
  static boolean[] jj_mask_201 = new boolean[117];
  static {
    jj_mask_201[DECR] = true;
  }
  static boolean[] jj_mask_202 = new boolean[117];
  static {
    jj_mask_202[INCR] = true;
  }
  
  final public void SwitchStatement() throws ParseError {
    jj_consume_token(SWITCH);
    jj_consume_token(LPAREN);
    Expression();
    jj_consume_token(RPAREN);
    jj_consume_token(LBRACE);
    label_38:
    while (true) {
      if (jj_mask_203[getToken(1).kind]) {
        ;
      } else {
        jj_expLA1[203] = jj_gen;
        break label_38;
      }
      SwitchLabel();
      label_39:
      while (true) {
        if (jj_mask_204[getToken(1).kind]) {
          ;
        } else {
          jj_expLA1[204] = jj_gen;
          break label_39;
        }
        BlockStatement();
      }
    }
    jj_consume_token(RBRACE);
  }

  static boolean[] jj_mask_203 = new boolean[117];
  static {
    jj_mask_203[CASE] =
    jj_mask_203[_DEFAULT] = true;
  }
  static boolean[] jj_mask_204 = new boolean[117];
  static {
    jj_mask_204[BOOLEAN] =
    jj_mask_204[BREAK] =
    jj_mask_204[BYTE] =
    jj_mask_204[CHAR] =
    jj_mask_204[CLASS] =
    jj_mask_204[CONTINUE] =
    jj_mask_204[DO] =
    jj_mask_204[DOUBLE] =
    jj_mask_204[FALSE] =
    jj_mask_204[FINAL] =
    jj_mask_204[FLOAT] =
    jj_mask_204[FOR] =
    jj_mask_204[IF] =
    jj_mask_204[INT] =
    jj_mask_204[LONG] =
    jj_mask_204[NEW] =
    jj_mask_204[NULL] =
    jj_mask_204[RETURN] =
    jj_mask_204[SHORT] =
    jj_mask_204[SUPER] =
    jj_mask_204[SWITCH] =
    jj_mask_204[SYNCHRONIZED] =
    jj_mask_204[THIS] =
    jj_mask_204[THROW] =
    jj_mask_204[TRUE] =
    jj_mask_204[TRY] =
    jj_mask_204[WHILE] =
    jj_mask_204[INTEGER_LITERAL] =
    jj_mask_204[FLOATING_POINT_LITERAL] =
    jj_mask_204[CHARACTER_LITERAL] =
    jj_mask_204[STRING_LITERAL] =
    jj_mask_204[IDENTIFIER] =
    jj_mask_204[LPAREN] =
    jj_mask_204[LBRACE] =
    jj_mask_204[SEMICOLON] =
    jj_mask_204[INCR] =
    jj_mask_204[DECR] = true;
  }
  
  final public void SwitchLabel() throws ParseError {
    if (jj_mask_206[getToken(1).kind]) {
      jj_consume_token(CASE);
      Expression();
      jj_consume_token(COLON);
    } else {
      jj_expLA1[206] = jj_gen;
      if (jj_mask_205[getToken(1).kind]) {
        jj_consume_token(_DEFAULT);
        jj_consume_token(COLON);
      } else {
        jj_expLA1[205] = jj_gen;
        jj_consume_token(-1);
        throw new ParseError();
      }
    }
  }

  static boolean[] jj_mask_205 = new boolean[117];
  static {
    jj_mask_205[_DEFAULT] = true;
  }
  static boolean[] jj_mask_206 = new boolean[117];
  static {
    jj_mask_206[CASE] = true;
  }
  
  final public void IfStatement() throws ParseError {
    jj_consume_token(IF);
    jj_consume_token(LPAREN);
    Expression();
    jj_consume_token(RPAREN);
    Statement();
    if (jj_mask_207[getToken(1).kind]) {
      jj_consume_token(ELSE);
      Statement();
    } else {
      jj_expLA1[207] = jj_gen;
      ;
    }
  }

  static boolean[] jj_mask_207 = new boolean[117];
  static {
    jj_mask_207[ELSE] = true;
  }
  
  final public void WhileStatement() throws ParseError {
    jj_consume_token(WHILE);
    jj_consume_token(LPAREN);
    Expression();
    jj_consume_token(RPAREN);
    Statement();
  }

  final public void DoStatement() throws ParseError {
    jj_consume_token(DO);
    Statement();
    jj_consume_token(WHILE);
    jj_consume_token(LPAREN);
    Expression();
    jj_consume_token(RPAREN);
    jj_consume_token(SEMICOLON);
  }

  final public void ForStatement() throws ParseError {
    jj_consume_token(FOR);
    jj_consume_token(LPAREN);
    if (jj_mask_208[getToken(1).kind]) {
      ForInit();
    } else {
      jj_expLA1[208] = jj_gen;
      ;
    }
    jj_consume_token(SEMICOLON);
    if (jj_mask_209[getToken(1).kind]) {
      Expression();
    } else {
      jj_expLA1[209] = jj_gen;
      ;
    }
    jj_consume_token(SEMICOLON);
    if (jj_mask_210[getToken(1).kind]) {
      ForUpdate();
    } else {
      jj_expLA1[210] = jj_gen;
      ;
    }
    jj_consume_token(RPAREN);
    Statement();
  }

  static boolean[] jj_mask_208 = new boolean[117];
  static {
    jj_mask_208[BOOLEAN] =
    jj_mask_208[BYTE] =
    jj_mask_208[CHAR] =
    jj_mask_208[DOUBLE] =
    jj_mask_208[FALSE] =
    jj_mask_208[FINAL] =
    jj_mask_208[FLOAT] =
    jj_mask_208[INT] =
    jj_mask_208[LONG] =
    jj_mask_208[NEW] =
    jj_mask_208[NULL] =
    jj_mask_208[SHORT] =
    jj_mask_208[SUPER] =
    jj_mask_208[THIS] =
    jj_mask_208[TRUE] =
    jj_mask_208[INTEGER_LITERAL] =
    jj_mask_208[FLOATING_POINT_LITERAL] =
    jj_mask_208[CHARACTER_LITERAL] =
    jj_mask_208[STRING_LITERAL] =
    jj_mask_208[IDENTIFIER] =
    jj_mask_208[LPAREN] =
    jj_mask_208[INCR] =
    jj_mask_208[DECR] = true;
  }
  static boolean[] jj_mask_209 = new boolean[117];
  static {
    jj_mask_209[BOOLEAN] =
    jj_mask_209[BYTE] =
    jj_mask_209[CHAR] =
    jj_mask_209[DOUBLE] =
    jj_mask_209[FALSE] =
    jj_mask_209[FLOAT] =
    jj_mask_209[INT] =
    jj_mask_209[LONG] =
    jj_mask_209[NEW] =
    jj_mask_209[NULL] =
    jj_mask_209[SHORT] =
    jj_mask_209[SUPER] =
    jj_mask_209[THIS] =
    jj_mask_209[TRUE] =
    jj_mask_209[INTEGER_LITERAL] =
    jj_mask_209[FLOATING_POINT_LITERAL] =
    jj_mask_209[CHARACTER_LITERAL] =
    jj_mask_209[STRING_LITERAL] =
    jj_mask_209[IDENTIFIER] =
    jj_mask_209[LPAREN] =
    jj_mask_209[BANG] =
    jj_mask_209[TILDE] =
    jj_mask_209[INCR] =
    jj_mask_209[DECR] =
    jj_mask_209[PLUS] =
    jj_mask_209[MINUS] = true;
  }
  static boolean[] jj_mask_210 = new boolean[117];
  static {
    jj_mask_210[BOOLEAN] =
    jj_mask_210[BYTE] =
    jj_mask_210[CHAR] =
    jj_mask_210[DOUBLE] =
    jj_mask_210[FALSE] =
    jj_mask_210[FLOAT] =
    jj_mask_210[INT] =
    jj_mask_210[LONG] =
    jj_mask_210[NEW] =
    jj_mask_210[NULL] =
    jj_mask_210[SHORT] =
    jj_mask_210[SUPER] =
    jj_mask_210[THIS] =
    jj_mask_210[TRUE] =
    jj_mask_210[INTEGER_LITERAL] =
    jj_mask_210[FLOATING_POINT_LITERAL] =
    jj_mask_210[CHARACTER_LITERAL] =
    jj_mask_210[STRING_LITERAL] =
    jj_mask_210[IDENTIFIER] =
    jj_mask_210[LPAREN] =
    jj_mask_210[INCR] =
    jj_mask_210[DECR] = true;
  }
  
  final public void ForInit() throws ParseError {
    if (jj_2_33(2147483647)) {
      LocalVariableDeclaration();
    } else {
      if (jj_mask_211[getToken(1).kind]) {
        StatementExpressionList();
      } else {
        jj_expLA1[211] = jj_gen;
        jj_consume_token(-1);
        throw new ParseError();
      }
    }
  }

  static boolean[] jj_mask_211 = new boolean[117];
  static {
    jj_mask_211[BOOLEAN] =
    jj_mask_211[BYTE] =
    jj_mask_211[CHAR] =
    jj_mask_211[DOUBLE] =
    jj_mask_211[FALSE] =
    jj_mask_211[FLOAT] =
    jj_mask_211[INT] =
    jj_mask_211[LONG] =
    jj_mask_211[NEW] =
    jj_mask_211[NULL] =
    jj_mask_211[SHORT] =
    jj_mask_211[SUPER] =
    jj_mask_211[THIS] =
    jj_mask_211[TRUE] =
    jj_mask_211[INTEGER_LITERAL] =
    jj_mask_211[FLOATING_POINT_LITERAL] =
    jj_mask_211[CHARACTER_LITERAL] =
    jj_mask_211[STRING_LITERAL] =
    jj_mask_211[IDENTIFIER] =
    jj_mask_211[LPAREN] =
    jj_mask_211[INCR] =
    jj_mask_211[DECR] = true;
  }
  
  final public void StatementExpressionList() throws ParseError {
    StatementExpression();
    label_40:
    while (true) {
      if (jj_mask_212[getToken(1).kind]) {
        ;
      } else {
        jj_expLA1[212] = jj_gen;
        break label_40;
      }
      jj_consume_token(COMMA);
      StatementExpression();
    }
  }

  static boolean[] jj_mask_212 = new boolean[117];
  static {
    jj_mask_212[COMMA] = true;
  }
  
  final public void ForUpdate() throws ParseError {
    StatementExpressionList();
  }

  final public void BreakStatement() throws ParseError {
    jj_consume_token(BREAK);
    if (jj_mask_213[getToken(1).kind]) {
      jj_consume_token(IDENTIFIER);
    } else {
      jj_expLA1[213] = jj_gen;
      ;
    }
    jj_consume_token(SEMICOLON);
  }

  static boolean[] jj_mask_213 = new boolean[117];
  static {
    jj_mask_213[IDENTIFIER] = true;
  }
  
  final public void ContinueStatement() throws ParseError {
    jj_consume_token(CONTINUE);
    if (jj_mask_214[getToken(1).kind]) {
      jj_consume_token(IDENTIFIER);
    } else {
      jj_expLA1[214] = jj_gen;
      ;
    }
    jj_consume_token(SEMICOLON);
  }

  static boolean[] jj_mask_214 = new boolean[117];
  static {
    jj_mask_214[IDENTIFIER] = true;
  }
  
  final public void ReturnStatement() throws ParseError {
    jj_consume_token(RETURN);
    if (jj_mask_215[getToken(1).kind]) {
      Expression();
    } else {
      jj_expLA1[215] = jj_gen;
      ;
    }
    jj_consume_token(SEMICOLON);
  }

  static boolean[] jj_mask_215 = new boolean[117];
  static {
    jj_mask_215[BOOLEAN] =
    jj_mask_215[BYTE] =
    jj_mask_215[CHAR] =
    jj_mask_215[DOUBLE] =
    jj_mask_215[FALSE] =
    jj_mask_215[FLOAT] =
    jj_mask_215[INT] =
    jj_mask_215[LONG] =
    jj_mask_215[NEW] =
    jj_mask_215[NULL] =
    jj_mask_215[SHORT] =
    jj_mask_215[SUPER] =
    jj_mask_215[THIS] =
    jj_mask_215[TRUE] =
    jj_mask_215[INTEGER_LITERAL] =
    jj_mask_215[FLOATING_POINT_LITERAL] =
    jj_mask_215[CHARACTER_LITERAL] =
    jj_mask_215[STRING_LITERAL] =
    jj_mask_215[IDENTIFIER] =
    jj_mask_215[LPAREN] =
    jj_mask_215[BANG] =
    jj_mask_215[TILDE] =
    jj_mask_215[INCR] =
    jj_mask_215[DECR] =
    jj_mask_215[PLUS] =
    jj_mask_215[MINUS] = true;
  }
  
  final public void ThrowStatement() throws ParseError {
    jj_consume_token(THROW);
    Expression();
    jj_consume_token(SEMICOLON);
  }

  final public void SynchronizedStatement() throws ParseError {
    jj_consume_token(SYNCHRONIZED);
    jj_consume_token(LPAREN);
    Expression();
    jj_consume_token(RPAREN);
    Block();
  }

  final public void TryStatement() throws ParseError {
    jj_consume_token(TRY);
    Block();
    label_41:
    while (true) {
      if (jj_mask_216[getToken(1).kind]) {
        ;
      } else {
        jj_expLA1[216] = jj_gen;
        break label_41;
      }
      jj_consume_token(CATCH);
      jj_consume_token(LPAREN);
      FormalParameter();
      jj_consume_token(RPAREN);
      Block();
    }
    if (jj_mask_217[getToken(1).kind]) {
      jj_consume_token(FINALLY);
      Block();
    } else {
      jj_expLA1[217] = jj_gen;
      ;
    }
  }

  static boolean[] jj_mask_216 = new boolean[117];
  static {
    jj_mask_216[CATCH] = true;
  }
  static boolean[] jj_mask_217 = new boolean[117];
  static {
    jj_mask_217[FINALLY] = true;
  }
  
  final private boolean jj_2_1(int xla) throws ParseError {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_1();
    jj_save(0, xla);
    return retval;
  }

  final private boolean jj_2_2(int xla) throws ParseError {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_2();
    jj_save(1, xla);
    return retval;
  }

  final private boolean jj_2_3(int xla) throws ParseError {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_3();
    jj_save(2, xla);
    return retval;
  }

  final private boolean jj_2_4(int xla) throws ParseError {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_4();
    jj_save(3, xla);
    return retval;
  }

  final private boolean jj_2_5(int xla) throws ParseError {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_5();
    jj_save(4, xla);
    return retval;
  }

  final private boolean jj_2_6(int xla) throws ParseError {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_6();
    jj_save(5, xla);
    return retval;
  }

  final private boolean jj_2_7(int xla) throws ParseError {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_7();
    jj_save(6, xla);
    return retval;
  }

  final private boolean jj_2_8(int xla) throws ParseError {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_8();
    jj_save(7, xla);
    return retval;
  }

  final private boolean jj_2_9(int xla) throws ParseError {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_9();
    jj_save(8, xla);
    return retval;
  }

  final private boolean jj_2_10(int xla) throws ParseError {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_10();
    jj_save(9, xla);
    return retval;
  }

  final private boolean jj_2_11(int xla) throws ParseError {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_11();
    jj_save(10, xla);
    return retval;
  }

  final private boolean jj_2_12(int xla) throws ParseError {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_12();
    jj_save(11, xla);
    return retval;
  }

  final private boolean jj_2_13(int xla) throws ParseError {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_13();
    jj_save(12, xla);
    return retval;
  }

  final private boolean jj_2_14(int xla) throws ParseError {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_14();
    jj_save(13, xla);
    return retval;
  }

  final private boolean jj_2_15(int xla) throws ParseError {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_15();
    jj_save(14, xla);
    return retval;
  }

  final private boolean jj_2_16(int xla) throws ParseError {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_16();
    jj_save(15, xla);
    return retval;
  }

  final private boolean jj_2_17(int xla) throws ParseError {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_17();
    jj_save(16, xla);
    return retval;
  }

  final private boolean jj_2_18(int xla) throws ParseError {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_18();
    jj_save(17, xla);
    return retval;
  }

  final private boolean jj_2_19(int xla) throws ParseError {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_19();
    jj_save(18, xla);
    return retval;
  }

  final private boolean jj_2_20(int xla) throws ParseError {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_20();
    jj_save(19, xla);
    return retval;
  }

  final private boolean jj_2_21(int xla) throws ParseError {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_21();
    jj_save(20, xla);
    return retval;
  }

  final private boolean jj_2_22(int xla) throws ParseError {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_22();
    jj_save(21, xla);
    return retval;
  }

  final private boolean jj_2_23(int xla) throws ParseError {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_23();
    jj_save(22, xla);
    return retval;
  }

  final private boolean jj_2_24(int xla) throws ParseError {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_24();
    jj_save(23, xla);
    return retval;
  }

  final private boolean jj_2_25(int xla) throws ParseError {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_25();
    jj_save(24, xla);
    return retval;
  }

  final private boolean jj_2_26(int xla) throws ParseError {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_26();
    jj_save(25, xla);
    return retval;
  }

  final private boolean jj_2_27(int xla) throws ParseError {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_27();
    jj_save(26, xla);
    return retval;
  }

  final private boolean jj_2_28(int xla) throws ParseError {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_28();
    jj_save(27, xla);
    return retval;
  }

  final private boolean jj_2_29(int xla) throws ParseError {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_29();
    jj_save(28, xla);
    return retval;
  }

  final private boolean jj_2_30(int xla) throws ParseError {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_30();
    jj_save(29, xla);
    return retval;
  }

  final private boolean jj_2_31(int xla) throws ParseError {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_31();
    jj_save(30, xla);
    return retval;
  }

  final private boolean jj_2_32(int xla) throws ParseError {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_32();
    jj_save(31, xla);
    return retval;
  }

  final private boolean jj_2_33(int xla) throws ParseError {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_33();
    jj_save(32, xla);
    return retval;
  }

  final private boolean jj_3_1() throws ParseError {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_42()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_scan_token(CLASS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_2() throws ParseError {
    if (jj_3R_43()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_3() throws ParseError {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_44()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_45()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_4() throws ParseError {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_46()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_scan_token(INTERFACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_5() throws ParseError {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_47()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_scan_token(CLASS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_6() throws ParseError {
    if (jj_3R_48()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_7() throws ParseError {
    if (jj_3R_43()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_8() throws ParseError {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_49()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_scan_token(INTERFACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_9() throws ParseError {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_50()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_scan_token(CLASS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_10() throws ParseError {
    if (jj_scan_token(COMMA)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_51()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_11() throws ParseError {
    if (jj_3R_52()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_12() throws ParseError {
    if (jj_3R_53()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(DOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_13() throws ParseError {
    if (jj_scan_token(THIS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_54()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_14() throws ParseError {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RBRACKET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_15() throws ParseError {
    if (jj_scan_token(DOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_16() throws ParseError {
    if (jj_3R_53()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_55()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_17() throws ParseError {
    if (jj_3R_56()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_18() throws ParseError {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_57()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_19() throws ParseError {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_58()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_20() throws ParseError {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_57()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_21() throws ParseError {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_58()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_22() throws ParseError {
    if (jj_3R_59()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_23() throws ParseError {
    if (jj_scan_token(DOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_60()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_24() throws ParseError {
    if (jj_scan_token(DOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(CLASS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_25() throws ParseError {
    if (jj_scan_token(DOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(THIS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_26() throws ParseError {
    if (jj_3R_61()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_27() throws ParseError {
    if (jj_scan_token(NEW)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_58()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_62()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_63()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_28() throws ParseError {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_64()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RBRACKET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_29() throws ParseError {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RBRACKET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_30() throws ParseError {
    if (jj_3R_65()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_31() throws ParseError {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_66()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_57()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_32() throws ParseError {
    if (jj_3R_53()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_55()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_33() throws ParseError {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_67()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_57()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_42() throws ParseError {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_68()) {
    jj_scanpos = xsp;
    if (jj_3R_69()) {
    jj_scanpos = xsp;
    if (jj_3R_70()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_43() throws ParseError {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_71()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_3R_72()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_44() throws ParseError {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_73()) {
    jj_scanpos = xsp;
    if (jj_3R_74()) {
    jj_scanpos = xsp;
    if (jj_3R_75()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_45() throws ParseError {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_15()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_46() throws ParseError {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_76()) {
    jj_scanpos = xsp;
    if (jj_3R_77()) {
    jj_scanpos = xsp;
    if (jj_3R_78()) {
    jj_scanpos = xsp;
    if (jj_3R_79()) {
    jj_scanpos = xsp;
    if (jj_3R_80()) {
    jj_scanpos = xsp;
    if (jj_3R_81()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_47() throws ParseError {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_82()) {
    jj_scanpos = xsp;
    if (jj_3R_83()) {
    jj_scanpos = xsp;
    if (jj_3R_84()) {
    jj_scanpos = xsp;
    if (jj_3R_85()) {
    jj_scanpos = xsp;
    if (jj_3R_86()) {
    jj_scanpos = xsp;
    if (jj_3R_87()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_48() throws ParseError {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_88()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_89()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_49() throws ParseError {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_90()) {
    jj_scanpos = xsp;
    if (jj_3R_91()) {
    jj_scanpos = xsp;
    if (jj_3R_92()) {
    jj_scanpos = xsp;
    if (jj_3R_93()) {
    jj_scanpos = xsp;
    if (jj_3R_94()) {
    jj_scanpos = xsp;
    if (jj_3R_95()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_50() throws ParseError {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_96()) {
    jj_scanpos = xsp;
    if (jj_3R_97()) {
    jj_scanpos = xsp;
    if (jj_3R_98()) {
    jj_scanpos = xsp;
    if (jj_3R_99()) {
    jj_scanpos = xsp;
    if (jj_3R_100()) {
    jj_scanpos = xsp;
    if (jj_3R_101()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_51() throws ParseError {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_102()) {
    jj_scanpos = xsp;
    if (jj_3R_103()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_52() throws ParseError {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_104()) {
    jj_scanpos = xsp;
    if (jj_3R_105()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_53() throws ParseError {
    if (jj_3R_106()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_22()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_54() throws ParseError {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_107()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_55() throws ParseError {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_108()) {
    jj_scanpos = xsp;
    if (jj_3R_109()) {
    jj_scanpos = xsp;
    if (jj_3R_110()) {
    jj_scanpos = xsp;
    if (jj_3R_111()) {
    jj_scanpos = xsp;
    if (jj_3R_112()) {
    jj_scanpos = xsp;
    if (jj_3R_113()) {
    jj_scanpos = xsp;
    if (jj_3R_114()) {
    jj_scanpos = xsp;
    if (jj_3R_115()) {
    jj_scanpos = xsp;
    if (jj_3R_116()) {
    jj_scanpos = xsp;
    if (jj_3R_117()) {
    jj_scanpos = xsp;
    if (jj_3R_118()) {
    jj_scanpos = xsp;
    if (jj_3R_119()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_56() throws ParseError {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_19()) {
    jj_scanpos = xsp;
    if (jj_3R_120()) {
    jj_scanpos = xsp;
    if (jj_3R_121()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_57() throws ParseError {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_122()) {
    jj_scanpos = xsp;
    if (jj_3R_123()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_14()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_58() throws ParseError {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_124()) {
    jj_scanpos = xsp;
    if (jj_3R_125()) {
    jj_scanpos = xsp;
    if (jj_3R_126()) {
    jj_scanpos = xsp;
    if (jj_3R_127()) {
    jj_scanpos = xsp;
    if (jj_3R_128()) {
    jj_scanpos = xsp;
    if (jj_3R_129()) {
    jj_scanpos = xsp;
    if (jj_3R_130()) {
    jj_scanpos = xsp;
    if (jj_3R_131()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_59() throws ParseError {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_25()) {
    jj_scanpos = xsp;
    if (jj_3_24()) {
    jj_scanpos = xsp;
    if (jj_3_23()) {
    jj_scanpos = xsp;
    if (jj_3R_132()) {
    jj_scanpos = xsp;
    if (jj_3R_133()) {
    jj_scanpos = xsp;
    if (jj_3R_134()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_60() throws ParseError {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_27()) {
    jj_scanpos = xsp;
    if (jj_3R_135()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_61() throws ParseError {
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_136()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_scan_token(RBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_62() throws ParseError {
    Token xsp;
    if (jj_3_28()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_28()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_29()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_63() throws ParseError {
    if (jj_3R_137()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_64() throws ParseError {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_138()) {
    jj_scanpos = xsp;
    if (jj_3R_139()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_65() throws ParseError {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(COLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_140()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_66() throws ParseError {
    if (jj_scan_token(FINAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_67() throws ParseError {
    if (jj_scan_token(FINAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_68() throws ParseError {
    if (jj_scan_token(ABSTRACT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_69() throws ParseError {
    if (jj_scan_token(FINAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_70() throws ParseError {
    if (jj_scan_token(PUBLIC)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_71() throws ParseError {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_141()) {
    jj_scanpos = xsp;
    if (jj_3R_142()) {
    jj_scanpos = xsp;
    if (jj_3R_143()) {
    jj_scanpos = xsp;
    if (jj_3R_144()) {
    jj_scanpos = xsp;
    if (jj_3R_145()) {
    jj_scanpos = xsp;
    if (jj_3R_146()) {
    jj_scanpos = xsp;
    if (jj_3R_147()) {
    jj_scanpos = xsp;
    if (jj_3R_148()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_72() throws ParseError {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_149()) {
    jj_scanpos = xsp;
    if (jj_3R_150()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_73() throws ParseError {
    if (jj_scan_token(PUBLIC)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_74() throws ParseError {
    if (jj_scan_token(PROTECTED)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_75() throws ParseError {
    if (jj_scan_token(PRIVATE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_76() throws ParseError {
    if (jj_scan_token(STATIC)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_77() throws ParseError {
    if (jj_scan_token(ABSTRACT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_78() throws ParseError {
    if (jj_scan_token(FINAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_79() throws ParseError {
    if (jj_scan_token(PUBLIC)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_80() throws ParseError {
    if (jj_scan_token(PROTECTED)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_81() throws ParseError {
    if (jj_scan_token(PRIVATE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_82() throws ParseError {
    if (jj_scan_token(STATIC)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_83() throws ParseError {
    if (jj_scan_token(ABSTRACT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_84() throws ParseError {
    if (jj_scan_token(FINAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_85() throws ParseError {
    if (jj_scan_token(PUBLIC)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_86() throws ParseError {
    if (jj_scan_token(PROTECTED)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_87() throws ParseError {
    if (jj_scan_token(PRIVATE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_88() throws ParseError {
    if (jj_scan_token(STATIC)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_89() throws ParseError {
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_151()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_scan_token(RBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_90() throws ParseError {
    if (jj_scan_token(STATIC)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_91() throws ParseError {
    if (jj_scan_token(ABSTRACT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_92() throws ParseError {
    if (jj_scan_token(FINAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_93() throws ParseError {
    if (jj_scan_token(PUBLIC)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_94() throws ParseError {
    if (jj_scan_token(PROTECTED)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_95() throws ParseError {
    if (jj_scan_token(PRIVATE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_96() throws ParseError {
    if (jj_scan_token(STATIC)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_97() throws ParseError {
    if (jj_scan_token(ABSTRACT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_98() throws ParseError {
    if (jj_scan_token(FINAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_99() throws ParseError {
    if (jj_scan_token(PUBLIC)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_100() throws ParseError {
    if (jj_scan_token(PROTECTED)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_101() throws ParseError {
    if (jj_scan_token(PRIVATE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_102() throws ParseError {
    if (jj_3R_137()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_103() throws ParseError {
    if (jj_3R_64()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_104() throws ParseError {
    if (jj_scan_token(THIS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_54()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_105() throws ParseError {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_12()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(SUPER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_54()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_106() throws ParseError {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_152()) {
    jj_scanpos = xsp;
    if (jj_3R_153()) {
    jj_scanpos = xsp;
    if (jj_3R_154()) {
    jj_scanpos = xsp;
    if (jj_3R_155()) {
    jj_scanpos = xsp;
    if (jj_3R_156()) {
    jj_scanpos = xsp;
    if (jj_3R_157()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_107() throws ParseError {
    if (jj_3R_158()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_108() throws ParseError {
    if (jj_scan_token(ASSIGN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_109() throws ParseError {
    if (jj_scan_token(STARASSIGN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_110() throws ParseError {
    if (jj_scan_token(SLASHASSIGN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_111() throws ParseError {
    if (jj_scan_token(REMASSIGN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_112() throws ParseError {
    if (jj_scan_token(PLUSASSIGN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_113() throws ParseError {
    if (jj_scan_token(MINUSASSIGN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_114() throws ParseError {
    if (jj_scan_token(LSHIFTASSIGN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_115() throws ParseError {
    if (jj_scan_token(RSIGNEDSHIFTASSIGN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_116() throws ParseError {
    if (jj_scan_token(RUNSIGNEDSHIFTASSIGN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_117() throws ParseError {
    if (jj_scan_token(ANDASSIGN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_118() throws ParseError {
    if (jj_scan_token(XORASSIGN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_119() throws ParseError {
    if (jj_scan_token(ORASSIGN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_120() throws ParseError {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_57()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RBRACKET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_121() throws ParseError {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_57()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_159()) {
    jj_scanpos = xsp;
    if (jj_3R_160()) {
    jj_scanpos = xsp;
    if (jj_3R_161()) {
    jj_scanpos = xsp;
    if (jj_3R_162()) {
    jj_scanpos = xsp;
    if (jj_3R_163()) {
    jj_scanpos = xsp;
    if (jj_3R_164()) {
    jj_scanpos = xsp;
    if (jj_3R_165()) {
    jj_scanpos = xsp;
    if (jj_3R_166()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_122() throws ParseError {
    if (jj_3R_58()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_123() throws ParseError {
    if (jj_3R_45()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_124() throws ParseError {
    if (jj_scan_token(BOOLEAN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_125() throws ParseError {
    if (jj_scan_token(CHAR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_126() throws ParseError {
    if (jj_scan_token(BYTE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_127() throws ParseError {
    if (jj_scan_token(SHORT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_128() throws ParseError {
    if (jj_scan_token(INT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_129() throws ParseError {
    if (jj_scan_token(LONG)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_130() throws ParseError {
    if (jj_scan_token(FLOAT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_131() throws ParseError {
    if (jj_scan_token(DOUBLE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_132() throws ParseError {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_64()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RBRACKET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_133() throws ParseError {
    if (jj_scan_token(DOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_134() throws ParseError {
    if (jj_3R_54()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_135() throws ParseError {
    if (jj_scan_token(NEW)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_57()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_167()) {
    jj_scanpos = xsp;
    if (jj_3R_168()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_136() throws ParseError {
    if (jj_3R_169()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_137() throws ParseError {
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_170()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3R_171()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_138() throws ParseError {
    if (jj_3R_172()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_139() throws ParseError {
    if (jj_3R_173()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_140() throws ParseError {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_30()) {
    jj_scanpos = xsp;
    if (jj_3R_174()) {
    jj_scanpos = xsp;
    if (jj_3R_175()) {
    jj_scanpos = xsp;
    if (jj_3R_176()) {
    jj_scanpos = xsp;
    if (jj_3R_177()) {
    jj_scanpos = xsp;
    if (jj_3R_178()) {
    jj_scanpos = xsp;
    if (jj_3R_179()) {
    jj_scanpos = xsp;
    if (jj_3R_180()) {
    jj_scanpos = xsp;
    if (jj_3R_181()) {
    jj_scanpos = xsp;
    if (jj_3R_182()) {
    jj_scanpos = xsp;
    if (jj_3R_183()) {
    jj_scanpos = xsp;
    if (jj_3R_184()) {
    jj_scanpos = xsp;
    if (jj_3R_185()) {
    jj_scanpos = xsp;
    if (jj_3R_186()) {
    jj_scanpos = xsp;
    if (jj_3R_187()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_141() throws ParseError {
    if (jj_scan_token(PUBLIC)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_142() throws ParseError {
    if (jj_scan_token(PROTECTED)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_143() throws ParseError {
    if (jj_scan_token(PRIVATE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_144() throws ParseError {
    if (jj_scan_token(STATIC)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_145() throws ParseError {
    if (jj_scan_token(ABSTRACT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_146() throws ParseError {
    if (jj_scan_token(FINAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_147() throws ParseError {
    if (jj_scan_token(NATIVE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_148() throws ParseError {
    if (jj_scan_token(SYNCHRONIZED)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_149() throws ParseError {
    if (jj_scan_token(VOID)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_150() throws ParseError {
    if (jj_3R_57()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_151() throws ParseError {
    if (jj_3R_188()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_152() throws ParseError {
    if (jj_3R_189()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_153() throws ParseError {
    if (jj_3R_57()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_154() throws ParseError {
    if (jj_scan_token(THIS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_155() throws ParseError {
    if (jj_scan_token(SUPER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(DOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_156() throws ParseError {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_64()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_157() throws ParseError {
    if (jj_3R_60()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_158() throws ParseError {
    if (jj_3R_64()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_190()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_159() throws ParseError {
    if (jj_scan_token(TILDE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_160() throws ParseError {
    if (jj_scan_token(BANG)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_161() throws ParseError {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_162() throws ParseError {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_163() throws ParseError {
    if (jj_scan_token(THIS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_164() throws ParseError {
    if (jj_scan_token(SUPER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_165() throws ParseError {
    if (jj_scan_token(NEW)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_166() throws ParseError {
    if (jj_3R_189()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_167() throws ParseError {
    if (jj_3R_62()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_191()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_168() throws ParseError {
    if (jj_3R_54()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_192()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_169() throws ParseError {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_6()) {
    jj_scanpos = xsp;
    if (jj_3R_193()) {
    jj_scanpos = xsp;
    if (jj_3R_194()) {
    jj_scanpos = xsp;
    if (jj_3R_195()) {
    jj_scanpos = xsp;
    if (jj_3R_196()) {
    jj_scanpos = xsp;
    if (jj_3R_197()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_170() throws ParseError {
    if (jj_3R_51()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_10()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_171() throws ParseError {
    if (jj_scan_token(COMMA)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_172() throws ParseError {
    if (jj_3R_53()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_55()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_64()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_173() throws ParseError {
    if (jj_3R_198()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_199()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_174() throws ParseError {
    if (jj_3R_89()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_175() throws ParseError {
    if (jj_3R_200()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_176() throws ParseError {
    if (jj_3R_201()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_177() throws ParseError {
    if (jj_3R_202()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_178() throws ParseError {
    if (jj_3R_203()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_179() throws ParseError {
    if (jj_3R_204()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_180() throws ParseError {
    if (jj_3R_205()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_181() throws ParseError {
    if (jj_3R_206()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_182() throws ParseError {
    if (jj_3R_207()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_183() throws ParseError {
    if (jj_3R_208()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_184() throws ParseError {
    if (jj_3R_209()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_185() throws ParseError {
    if (jj_3R_210()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_186() throws ParseError {
    if (jj_3R_211()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_187() throws ParseError {
    if (jj_3R_212()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_188() throws ParseError {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_213()) {
    jj_scanpos = xsp;
    if (jj_3R_214()) {
    jj_scanpos = xsp;
    if (jj_3R_215()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_189() throws ParseError {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_216()) {
    jj_scanpos = xsp;
    if (jj_3R_217()) {
    jj_scanpos = xsp;
    if (jj_3R_218()) {
    jj_scanpos = xsp;
    if (jj_3R_219()) {
    jj_scanpos = xsp;
    if (jj_3R_220()) {
    jj_scanpos = xsp;
    if (jj_3R_221()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_190() throws ParseError {
    if (jj_scan_token(COMMA)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_64()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_191() throws ParseError {
    if (jj_3R_137()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_192() throws ParseError {
    if (jj_3R_61()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_193() throws ParseError {
    if (jj_3R_222()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_194() throws ParseError {
    if (jj_3R_223()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_195() throws ParseError {
    if (jj_3R_224()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_196() throws ParseError {
    if (jj_3R_225()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_197() throws ParseError {
    if (jj_3R_226()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_198() throws ParseError {
    if (jj_3R_227()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_228()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_199() throws ParseError {
    if (jj_scan_token(HOOK)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_64()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(COLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_173()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_200() throws ParseError {
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_201() throws ParseError {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_229()) {
    jj_scanpos = xsp;
    if (jj_3R_230()) {
    jj_scanpos = xsp;
    if (jj_3R_231()) {
    jj_scanpos = xsp;
    if (jj_3R_232()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_202() throws ParseError {
    if (jj_scan_token(SWITCH)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_64()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_233()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_scan_token(RBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_203() throws ParseError {
    if (jj_scan_token(IF)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_64()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_140()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_234()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_204() throws ParseError {
    if (jj_scan_token(WHILE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_64()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_140()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_205() throws ParseError {
    if (jj_scan_token(DO)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_140()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(WHILE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_64()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_206() throws ParseError {
    if (jj_scan_token(FOR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_235()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3R_236()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3R_237()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_140()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_207() throws ParseError {
    if (jj_scan_token(BREAK)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_238()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_208() throws ParseError {
    if (jj_scan_token(CONTINUE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_239()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_209() throws ParseError {
    if (jj_scan_token(RETURN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_240()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_210() throws ParseError {
    if (jj_scan_token(THROW)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_64()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_211() throws ParseError {
    if (jj_scan_token(SYNCHRONIZED)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_64()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_89()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_212() throws ParseError {
    if (jj_scan_token(TRY)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_89()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_241()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    xsp = jj_scanpos;
    if (jj_3R_242()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_213() throws ParseError {
    if (jj_3R_243()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_214() throws ParseError {
    if (jj_3R_140()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_215() throws ParseError {
    if (jj_3R_244()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_216() throws ParseError {
    if (jj_scan_token(INTEGER_LITERAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_217() throws ParseError {
    if (jj_scan_token(FLOATING_POINT_LITERAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_218() throws ParseError {
    if (jj_scan_token(CHARACTER_LITERAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_219() throws ParseError {
    if (jj_scan_token(STRING_LITERAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_220() throws ParseError {
    if (jj_3R_245()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_221() throws ParseError {
    if (jj_3R_246()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_222() throws ParseError {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_247()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_3R_244()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_223() throws ParseError {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_248()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_3R_249()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_224() throws ParseError {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_250()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_251()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3R_252()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3R_253()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_254()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_scan_token(RBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_225() throws ParseError {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_255()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_3R_72()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_256()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3R_257()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3R_258()) {
    jj_scanpos = xsp;
    if (jj_3R_259()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_226() throws ParseError {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_260()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_3R_57()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_261()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_262()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_227() throws ParseError {
    if (jj_3R_263()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_264()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_228() throws ParseError {
    if (jj_scan_token(SC_OR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_227()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_229() throws ParseError {
    if (jj_3R_265()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_230() throws ParseError {
    if (jj_3R_266()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_231() throws ParseError {
    if (jj_3R_172()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_232() throws ParseError {
    if (jj_3R_267()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_233() throws ParseError {
    if (jj_3R_268()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_269()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_234() throws ParseError {
    if (jj_scan_token(ELSE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_140()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_235() throws ParseError {
    if (jj_3R_270()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_236() throws ParseError {
    if (jj_3R_64()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_237() throws ParseError {
    if (jj_3R_271()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_238() throws ParseError {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_239() throws ParseError {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_240() throws ParseError {
    if (jj_3R_64()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_241() throws ParseError {
    if (jj_scan_token(CATCH)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_272()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_89()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_242() throws ParseError {
    if (jj_scan_token(FINALLY)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_89()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_243() throws ParseError {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_273()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_57()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_261()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_274()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_244() throws ParseError {
    if (jj_scan_token(CLASS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_275()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3R_276()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_61()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_245() throws ParseError {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_277()) {
    jj_scanpos = xsp;
    if (jj_3R_278()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_246() throws ParseError {
    if (jj_scan_token(NULL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_247() throws ParseError {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_279()) {
    jj_scanpos = xsp;
    if (jj_3R_280()) {
    jj_scanpos = xsp;
    if (jj_3R_281()) {
    jj_scanpos = xsp;
    if (jj_3R_282()) {
    jj_scanpos = xsp;
    if (jj_3R_283()) {
    jj_scanpos = xsp;
    if (jj_3R_284()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_248() throws ParseError {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_285()) {
    jj_scanpos = xsp;
    if (jj_3R_286()) {
    jj_scanpos = xsp;
    if (jj_3R_287()) {
    jj_scanpos = xsp;
    if (jj_3R_288()) {
    jj_scanpos = xsp;
    if (jj_3R_289()) {
    jj_scanpos = xsp;
    if (jj_3R_290()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_249() throws ParseError {
    if (jj_scan_token(INTERFACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_291()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_292()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_scan_token(RBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_250() throws ParseError {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_293()) {
    jj_scanpos = xsp;
    if (jj_3R_294()) {
    jj_scanpos = xsp;
    if (jj_3R_295()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_251() throws ParseError {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_296()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_252() throws ParseError {
    if (jj_scan_token(THROWS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_297()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_253() throws ParseError {
    if (jj_3R_52()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_254() throws ParseError {
    if (jj_3R_188()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_255() throws ParseError {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_298()) {
    jj_scanpos = xsp;
    if (jj_3R_299()) {
    jj_scanpos = xsp;
    if (jj_3R_300()) {
    jj_scanpos = xsp;
    if (jj_3R_301()) {
    jj_scanpos = xsp;
    if (jj_3R_302()) {
    jj_scanpos = xsp;
    if (jj_3R_303()) {
    jj_scanpos = xsp;
    if (jj_3R_304()) {
    jj_scanpos = xsp;
    if (jj_3R_305()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_256() throws ParseError {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_251()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_306()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_257() throws ParseError {
    if (jj_scan_token(THROWS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_297()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_258() throws ParseError {
    if (jj_3R_89()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_259() throws ParseError {
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_260() throws ParseError {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_307()) {
    jj_scanpos = xsp;
    if (jj_3R_308()) {
    jj_scanpos = xsp;
    if (jj_3R_309()) {
    jj_scanpos = xsp;
    if (jj_3R_310()) {
    jj_scanpos = xsp;
    if (jj_3R_311()) {
    jj_scanpos = xsp;
    if (jj_3R_312()) {
    jj_scanpos = xsp;
    if (jj_3R_313()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_261() throws ParseError {
    if (jj_3R_314()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_315()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_262() throws ParseError {
    if (jj_scan_token(COMMA)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_261()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_263() throws ParseError {
    if (jj_3R_316()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_317()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_264() throws ParseError {
    if (jj_scan_token(SC_AND)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_263()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_265() throws ParseError {
    if (jj_scan_token(INCR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_53()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_266() throws ParseError {
    if (jj_scan_token(DECR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_53()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_267() throws ParseError {
    if (jj_3R_53()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_318()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_268() throws ParseError {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_319()) {
    jj_scanpos = xsp;
    if (jj_3R_320()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_269() throws ParseError {
    if (jj_3R_188()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_270() throws ParseError {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_321()) {
    jj_scanpos = xsp;
    if (jj_3R_322()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_271() throws ParseError {
    if (jj_3R_323()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_272() throws ParseError {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_324()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_57()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_314()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_273() throws ParseError {
    if (jj_scan_token(FINAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_274() throws ParseError {
    if (jj_scan_token(COMMA)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_261()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_275() throws ParseError {
    if (jj_scan_token(EXTENDS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_57()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_276() throws ParseError {
    if (jj_scan_token(IMPLEMENTS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_297()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_277() throws ParseError {
    if (jj_scan_token(TRUE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_278() throws ParseError {
    if (jj_scan_token(FALSE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_279() throws ParseError {
    if (jj_scan_token(STATIC)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_280() throws ParseError {
    if (jj_scan_token(ABSTRACT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_281() throws ParseError {
    if (jj_scan_token(FINAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_282() throws ParseError {
    if (jj_scan_token(PUBLIC)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_283() throws ParseError {
    if (jj_scan_token(PROTECTED)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_284() throws ParseError {
    if (jj_scan_token(PRIVATE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_285() throws ParseError {
    if (jj_scan_token(STATIC)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_286() throws ParseError {
    if (jj_scan_token(ABSTRACT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_287() throws ParseError {
    if (jj_scan_token(FINAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_288() throws ParseError {
    if (jj_scan_token(PUBLIC)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_289() throws ParseError {
    if (jj_scan_token(PROTECTED)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_290() throws ParseError {
    if (jj_scan_token(PRIVATE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_291() throws ParseError {
    if (jj_scan_token(EXTENDS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_297()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_292() throws ParseError {
    if (jj_3R_325()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_293() throws ParseError {
    if (jj_scan_token(PUBLIC)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_294() throws ParseError {
    if (jj_scan_token(PROTECTED)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_295() throws ParseError {
    if (jj_scan_token(PRIVATE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_296() throws ParseError {
    if (jj_3R_272()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_326()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_297() throws ParseError {
    if (jj_3R_57()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_327()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_298() throws ParseError {
    if (jj_scan_token(PUBLIC)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_299() throws ParseError {
    if (jj_scan_token(PROTECTED)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_300() throws ParseError {
    if (jj_scan_token(PRIVATE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_301() throws ParseError {
    if (jj_scan_token(STATIC)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_302() throws ParseError {
    if (jj_scan_token(ABSTRACT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_303() throws ParseError {
    if (jj_scan_token(FINAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_304() throws ParseError {
    if (jj_scan_token(NATIVE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_305() throws ParseError {
    if (jj_scan_token(SYNCHRONIZED)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_306() throws ParseError {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RBRACKET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_307() throws ParseError {
    if (jj_scan_token(PUBLIC)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_308() throws ParseError {
    if (jj_scan_token(PROTECTED)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_309() throws ParseError {
    if (jj_scan_token(PRIVATE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_310() throws ParseError {
    if (jj_scan_token(STATIC)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_311() throws ParseError {
    if (jj_scan_token(FINAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_312() throws ParseError {
    if (jj_scan_token(TRANSIENT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_313() throws ParseError {
    if (jj_scan_token(VOLATILE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_314() throws ParseError {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_328()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_315() throws ParseError {
    if (jj_scan_token(ASSIGN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_51()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_316() throws ParseError {
    if (jj_3R_329()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_330()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_317() throws ParseError {
    if (jj_scan_token(BIT_OR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_316()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_318() throws ParseError {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_331()) {
    jj_scanpos = xsp;
    if (jj_3R_332()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_319() throws ParseError {
    if (jj_scan_token(CASE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_64()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(COLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_320() throws ParseError {
    if (jj_scan_token(_DEFAULT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(COLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_321() throws ParseError {
    if (jj_3R_243()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_322() throws ParseError {
    if (jj_3R_323()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_323() throws ParseError {
    if (jj_3R_201()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_333()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_324() throws ParseError {
    if (jj_scan_token(FINAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_325() throws ParseError {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_334()) {
    jj_scanpos = xsp;
    if (jj_3R_335()) {
    jj_scanpos = xsp;
    if (jj_3R_336()) {
    jj_scanpos = xsp;
    if (jj_3R_337()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_326() throws ParseError {
    if (jj_scan_token(COMMA)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_272()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_327() throws ParseError {
    if (jj_scan_token(COMMA)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_57()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_328() throws ParseError {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RBRACKET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_329() throws ParseError {
    if (jj_3R_338()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_339()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_330() throws ParseError {
    if (jj_scan_token(XOR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_329()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_331() throws ParseError {
    if (jj_scan_token(INCR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_332() throws ParseError {
    if (jj_scan_token(DECR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_333() throws ParseError {
    if (jj_scan_token(COMMA)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_201()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_334() throws ParseError {
    if (jj_3R_222()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_335() throws ParseError {
    if (jj_3R_223()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_336() throws ParseError {
    if (jj_3R_225()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_337() throws ParseError {
    if (jj_3R_226()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_338() throws ParseError {
    if (jj_3R_340()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_341()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_339() throws ParseError {
    if (jj_scan_token(BIT_AND)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_338()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_340() throws ParseError {
    if (jj_3R_342()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_343()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_341() throws ParseError {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_344()) {
    jj_scanpos = xsp;
    if (jj_3R_345()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_340()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_342() throws ParseError {
    if (jj_3R_346()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_347()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_343() throws ParseError {
    if (jj_scan_token(INSTANCEOF)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_57()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_344() throws ParseError {
    if (jj_scan_token(EQ)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_345() throws ParseError {
    if (jj_scan_token(NE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_346() throws ParseError {
    if (jj_3R_348()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_349()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_347() throws ParseError {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_350()) {
    jj_scanpos = xsp;
    if (jj_3R_351()) {
    jj_scanpos = xsp;
    if (jj_3R_352()) {
    jj_scanpos = xsp;
    if (jj_3R_353()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_346()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_348() throws ParseError {
    if (jj_3R_354()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_355()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_349() throws ParseError {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_356()) {
    jj_scanpos = xsp;
    if (jj_3R_357()) {
    jj_scanpos = xsp;
    if (jj_3R_358()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_348()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_350() throws ParseError {
    if (jj_scan_token(LT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_351() throws ParseError {
    if (jj_scan_token(GT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_352() throws ParseError {
    if (jj_scan_token(LE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_353() throws ParseError {
    if (jj_scan_token(GE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_354() throws ParseError {
    if (jj_3R_359()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_360()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_355() throws ParseError {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_361()) {
    jj_scanpos = xsp;
    if (jj_3R_362()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_354()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_356() throws ParseError {
    if (jj_scan_token(LSHIFT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_357() throws ParseError {
    if (jj_scan_token(RSIGNEDSHIFT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_358() throws ParseError {
    if (jj_scan_token(RUNSIGNEDSHIFT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_359() throws ParseError {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_363()) {
    jj_scanpos = xsp;
    if (jj_3R_364()) {
    jj_scanpos = xsp;
    if (jj_3R_365()) {
    jj_scanpos = xsp;
    if (jj_3R_366()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_360() throws ParseError {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_367()) {
    jj_scanpos = xsp;
    if (jj_3R_368()) {
    jj_scanpos = xsp;
    if (jj_3R_369()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_359()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_361() throws ParseError {
    if (jj_scan_token(PLUS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_362() throws ParseError {
    if (jj_scan_token(MINUS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_363() throws ParseError {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_370()) {
    jj_scanpos = xsp;
    if (jj_3R_371()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_359()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_364() throws ParseError {
    if (jj_3R_265()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_365() throws ParseError {
    if (jj_3R_266()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_366() throws ParseError {
    if (jj_3R_372()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_367() throws ParseError {
    if (jj_scan_token(STAR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_368() throws ParseError {
    if (jj_scan_token(SLASH)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_369() throws ParseError {
    if (jj_scan_token(REM)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_370() throws ParseError {
    if (jj_scan_token(PLUS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_371() throws ParseError {
    if (jj_scan_token(MINUS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_372() throws ParseError {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_373()) {
    jj_scanpos = xsp;
    if (jj_3R_374()) {
    jj_scanpos = xsp;
    if (jj_3R_375()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_373() throws ParseError {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_376()) {
    jj_scanpos = xsp;
    if (jj_3R_377()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_359()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_374() throws ParseError {
    if (jj_3R_378()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_375() throws ParseError {
    if (jj_3R_267()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_376() throws ParseError {
    if (jj_scan_token(TILDE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_377() throws ParseError {
    if (jj_scan_token(BANG)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_378() throws ParseError {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_379()) {
    jj_scanpos = xsp;
    if (jj_3R_380()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_379() throws ParseError {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_57()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_359()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_380() throws ParseError {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_57()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_372()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  public JavaDependTokenManager token_source;
  public Token token;
  private Token jj_scanpos, jj_lastpos;
  private int jj_la;
  public boolean lookingAhead = false;
  private boolean jj_semLA;
  private JavaDepend jj_me;
  private int jj_gen;
  private int[] jj_expLA1 = new int[218];
  private JJJavaDependCalls[] jj_2_rtns = new JJJavaDependCalls[33];
  private boolean jj_rescan = false;

  public JavaDepend(java.io.InputStream stream) {
    ASCII_UCodeESC_CharStream input_stream = new ASCII_UCodeESC_CharStream(stream, 1, 1);
    token_source = new JavaDependTokenManager(input_stream);
    token = new Token();
    jj_me = this;
    jj_gen = 0;
    for (int i = 0; i < 218; i++) jj_expLA1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJJavaDependCalls();
  }

  public void ReInit(java.io.InputStream stream) {
    ASCII_UCodeESC_CharStream input_stream = new ASCII_UCodeESC_CharStream(stream, 1, 1);
    token_source.ReInit(input_stream);
    token = new Token();
    jj_gen = 0;
    for (int i = 0; i < 218; i++) jj_expLA1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJJavaDependCalls();
  }

  public JavaDepend(JavaDependTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_me = this;
    jj_gen = 0;
    for (int i = 0; i < 218; i++) jj_expLA1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJJavaDependCalls();
  }

  public void ReInit(JavaDependTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_gen = 0;
    for (int i = 0; i < 218; i++) jj_expLA1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJJavaDependCalls();
  }

  final private Token jj_consume_token(int kind) throws ParseError {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    if (token.kind == kind) {
      jj_gen++;
      return token;
    }
    jj_token_error_setup(token, kind);
    throw new ParseError();
  }

  final private boolean jj_scan_token(int kind) throws ParseError {
    if (jj_scanpos == jj_lastpos) {
      jj_la--;
      if (jj_scanpos.next == null) {
        jj_lastpos = jj_scanpos = jj_scanpos.next = token_source.getNextToken();
      } else {
        jj_lastpos = jj_scanpos = jj_scanpos.next;
      }
    } else {
      jj_scanpos = jj_scanpos.next;
    }
    if (jj_rescan) {
      int i = 1; Token tok = token;
      while (tok != null && tok != jj_scanpos) { i++; tok = tok.next; }
      if (tok != null) jj_add_error_token(kind, i);
    }
    return (jj_scanpos.kind != kind);
  }

  final public Token getNextToken() throws ParseError {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_gen++;
    return token;
  }

  final public Token getToken(int index) throws ParseError {
    Token t = lookingAhead ? jj_scanpos : token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  static final String jj_add_escapes(String str) {
    String retval = "";
    char ch;
    for (int i = 0; i < str.length(); i++) {
      ch = str.charAt(i);
      if (ch == '\b') {
        retval += "\\b";
      } else if (ch == '\t') {
        retval += "\\t";
      } else if (ch == '\n') {
        retval += "\\n";
      } else if (ch == '\f') {
        retval += "\\f";
      } else if (ch == '\r') {
        retval += "\\r";
      } else if (ch == '\"') {
        retval += "\\\"";
      } else if (ch == '\'') {
        retval += "\\\'";
      } else if (ch == '\\') {
        retval += "\\\\";
      } else if (ch < 0x20 || ch > 0x7e) {
        String s = "0000" + Integer.toString(ch, 16);
        retval += "\\u" + s.substring(s.length() - 4, s.length());
      } else {
        retval += ch;
      }
    }
    return retval;
  }

  protected int error_line;
  protected int error_column;
  protected String error_string;
  protected String[] expected_tokens;

  protected void token_error() {
    System.out.println("");
    System.out.println("Parse error at line " + error_line + ", column " + error_column + ".  Encountered:");
    System.out.println("    \"" + jj_add_escapes(error_string) + "\"");
    System.out.println("");
    if (expected_tokens.length == 1) {
      System.out.println("Was expecting:");
    } else {
      System.out.println("Was expecting one of:");
    }
    for (int i = 0; i < expected_tokens.length; i++) {
      System.out.println("    " + expected_tokens[i]);
    }
    System.out.println("");
  }

  private java.util.Vector jj_errortokens = new java.util.Vector();
  private int[] jj_lasttokens = new int[100];
  private int jj_endpos, jj_maxsize;

  private void jj_add_error_token(int kind, int pos) {
    if (pos >= 100) return;
    if (pos == jj_endpos + 1) {
      jj_lasttokens[jj_endpos++] = kind;
    } else if (jj_endpos != 0) {
      if (jj_endpos > jj_maxsize) jj_maxsize = jj_endpos;
      String buf = "";
      for (int i = 0; i < jj_endpos; i++) {
        buf += tokenImage[jj_lasttokens[i]] + " ";
      }
      if (jj_lasttokens[jj_endpos-1] != 0) buf += "...";
      boolean exists = false;
      for (java.util.Enumeration enum = jj_errortokens.elements(); enum.hasMoreElements();) {
        if (buf.equals((String)(enum.nextElement()))) {
          exists = true;
        }
      }
      if (!exists) jj_errortokens.addElement(buf);
      if (pos != 0) jj_lasttokens[(jj_endpos = pos) - 1] = kind;
    }
  }

  final private void jj_token_error_setup(Token current, int kind) throws ParseError {
    jj_errortokens.removeAllElements();
    boolean[] la1tokens = new boolean[117];
    boolean[] mask = null;
    for (int i = 0; i < 117; i++) {
      la1tokens[i] = false;
    }
    if (kind >= 0) la1tokens[kind] = true;
    for (int i = 0; i < 218; i++) {
      if (jj_expLA1[i] == jj_gen) {
        switch (i) {
          case 0: mask = jj_mask_0; break;
          case 1: mask = jj_mask_1; break;
          case 2: mask = jj_mask_2; break;
          case 3: mask = jj_mask_3; break;
          case 4: mask = jj_mask_4; break;
          case 5: mask = jj_mask_5; break;
          case 6: mask = jj_mask_6; break;
          case 7: mask = jj_mask_7; break;
          case 8: mask = jj_mask_8; break;
          case 9: mask = jj_mask_9; break;
          case 10: mask = jj_mask_10; break;
          case 11: mask = jj_mask_11; break;
          case 12: mask = jj_mask_12; break;
          case 13: mask = jj_mask_13; break;
          case 14: mask = jj_mask_14; break;
          case 15: mask = jj_mask_15; break;
          case 16: mask = jj_mask_16; break;
          case 17: mask = jj_mask_17; break;
          case 18: mask = jj_mask_18; break;
          case 19: mask = jj_mask_19; break;
          case 20: mask = jj_mask_20; break;
          case 21: mask = jj_mask_21; break;
          case 22: mask = jj_mask_22; break;
          case 23: mask = jj_mask_23; break;
          case 24: mask = jj_mask_24; break;
          case 25: mask = jj_mask_25; break;
          case 26: mask = jj_mask_26; break;
          case 27: mask = jj_mask_27; break;
          case 28: mask = jj_mask_28; break;
          case 29: mask = jj_mask_29; break;
          case 30: mask = jj_mask_30; break;
          case 31: mask = jj_mask_31; break;
          case 32: mask = jj_mask_32; break;
          case 33: mask = jj_mask_33; break;
          case 34: mask = jj_mask_34; break;
          case 35: mask = jj_mask_35; break;
          case 36: mask = jj_mask_36; break;
          case 37: mask = jj_mask_37; break;
          case 38: mask = jj_mask_38; break;
          case 39: mask = jj_mask_39; break;
          case 40: mask = jj_mask_40; break;
          case 41: mask = jj_mask_41; break;
          case 42: mask = jj_mask_42; break;
          case 43: mask = jj_mask_43; break;
          case 44: mask = jj_mask_44; break;
          case 45: mask = jj_mask_45; break;
          case 46: mask = jj_mask_46; break;
          case 47: mask = jj_mask_47; break;
          case 48: mask = jj_mask_48; break;
          case 49: mask = jj_mask_49; break;
          case 50: mask = jj_mask_50; break;
          case 51: mask = jj_mask_51; break;
          case 52: mask = jj_mask_52; break;
          case 53: mask = jj_mask_53; break;
          case 54: mask = jj_mask_54; break;
          case 55: mask = jj_mask_55; break;
          case 56: mask = jj_mask_56; break;
          case 57: mask = jj_mask_57; break;
          case 58: mask = jj_mask_58; break;
          case 59: mask = jj_mask_59; break;
          case 60: mask = jj_mask_60; break;
          case 61: mask = jj_mask_61; break;
          case 62: mask = jj_mask_62; break;
          case 63: mask = jj_mask_63; break;
          case 64: mask = jj_mask_64; break;
          case 65: mask = jj_mask_65; break;
          case 66: mask = jj_mask_66; break;
          case 67: mask = jj_mask_67; break;
          case 68: mask = jj_mask_68; break;
          case 69: mask = jj_mask_69; break;
          case 70: mask = jj_mask_70; break;
          case 71: mask = jj_mask_71; break;
          case 72: mask = jj_mask_72; break;
          case 73: mask = jj_mask_73; break;
          case 74: mask = jj_mask_74; break;
          case 75: mask = jj_mask_75; break;
          case 76: mask = jj_mask_76; break;
          case 77: mask = jj_mask_77; break;
          case 78: mask = jj_mask_78; break;
          case 79: mask = jj_mask_79; break;
          case 80: mask = jj_mask_80; break;
          case 81: mask = jj_mask_81; break;
          case 82: mask = jj_mask_82; break;
          case 83: mask = jj_mask_83; break;
          case 84: mask = jj_mask_84; break;
          case 85: mask = jj_mask_85; break;
          case 86: mask = jj_mask_86; break;
          case 87: mask = jj_mask_87; break;
          case 88: mask = jj_mask_88; break;
          case 89: mask = jj_mask_89; break;
          case 90: mask = jj_mask_90; break;
          case 91: mask = jj_mask_91; break;
          case 92: mask = jj_mask_92; break;
          case 93: mask = jj_mask_93; break;
          case 94: mask = jj_mask_94; break;
          case 95: mask = jj_mask_95; break;
          case 96: mask = jj_mask_96; break;
          case 97: mask = jj_mask_97; break;
          case 98: mask = jj_mask_98; break;
          case 99: mask = jj_mask_99; break;
          case 100: mask = jj_mask_100; break;
          case 101: mask = jj_mask_101; break;
          case 102: mask = jj_mask_102; break;
          case 103: mask = jj_mask_103; break;
          case 104: mask = jj_mask_104; break;
          case 105: mask = jj_mask_105; break;
          case 106: mask = jj_mask_106; break;
          case 107: mask = jj_mask_107; break;
          case 108: mask = jj_mask_108; break;
          case 109: mask = jj_mask_109; break;
          case 110: mask = jj_mask_110; break;
          case 111: mask = jj_mask_111; break;
          case 112: mask = jj_mask_112; break;
          case 113: mask = jj_mask_113; break;
          case 114: mask = jj_mask_114; break;
          case 115: mask = jj_mask_115; break;
          case 116: mask = jj_mask_116; break;
          case 117: mask = jj_mask_117; break;
          case 118: mask = jj_mask_118; break;
          case 119: mask = jj_mask_119; break;
          case 120: mask = jj_mask_120; break;
          case 121: mask = jj_mask_121; break;
          case 122: mask = jj_mask_122; break;
          case 123: mask = jj_mask_123; break;
          case 124: mask = jj_mask_124; break;
          case 125: mask = jj_mask_125; break;
          case 126: mask = jj_mask_126; break;
          case 127: mask = jj_mask_127; break;
          case 128: mask = jj_mask_128; break;
          case 129: mask = jj_mask_129; break;
          case 130: mask = jj_mask_130; break;
          case 131: mask = jj_mask_131; break;
          case 132: mask = jj_mask_132; break;
          case 133: mask = jj_mask_133; break;
          case 134: mask = jj_mask_134; break;
          case 135: mask = jj_mask_135; break;
          case 136: mask = jj_mask_136; break;
          case 137: mask = jj_mask_137; break;
          case 138: mask = jj_mask_138; break;
          case 139: mask = jj_mask_139; break;
          case 140: mask = jj_mask_140; break;
          case 141: mask = jj_mask_141; break;
          case 142: mask = jj_mask_142; break;
          case 143: mask = jj_mask_143; break;
          case 144: mask = jj_mask_144; break;
          case 145: mask = jj_mask_145; break;
          case 146: mask = jj_mask_146; break;
          case 147: mask = jj_mask_147; break;
          case 148: mask = jj_mask_148; break;
          case 149: mask = jj_mask_149; break;
          case 150: mask = jj_mask_150; break;
          case 151: mask = jj_mask_151; break;
          case 152: mask = jj_mask_152; break;
          case 153: mask = jj_mask_153; break;
          case 154: mask = jj_mask_154; break;
          case 155: mask = jj_mask_155; break;
          case 156: mask = jj_mask_156; break;
          case 157: mask = jj_mask_157; break;
          case 158: mask = jj_mask_158; break;
          case 159: mask = jj_mask_159; break;
          case 160: mask = jj_mask_160; break;
          case 161: mask = jj_mask_161; break;
          case 162: mask = jj_mask_162; break;
          case 163: mask = jj_mask_163; break;
          case 164: mask = jj_mask_164; break;
          case 165: mask = jj_mask_165; break;
          case 166: mask = jj_mask_166; break;
          case 167: mask = jj_mask_167; break;
          case 168: mask = jj_mask_168; break;
          case 169: mask = jj_mask_169; break;
          case 170: mask = jj_mask_170; break;
          case 171: mask = jj_mask_171; break;
          case 172: mask = jj_mask_172; break;
          case 173: mask = jj_mask_173; break;
          case 174: mask = jj_mask_174; break;
          case 175: mask = jj_mask_175; break;
          case 176: mask = jj_mask_176; break;
          case 177: mask = jj_mask_177; break;
          case 178: mask = jj_mask_178; break;
          case 179: mask = jj_mask_179; break;
          case 180: mask = jj_mask_180; break;
          case 181: mask = jj_mask_181; break;
          case 182: mask = jj_mask_182; break;
          case 183: mask = jj_mask_183; break;
          case 184: mask = jj_mask_184; break;
          case 185: mask = jj_mask_185; break;
          case 186: mask = jj_mask_186; break;
          case 187: mask = jj_mask_187; break;
          case 188: mask = jj_mask_188; break;
          case 189: mask = jj_mask_189; break;
          case 190: mask = jj_mask_190; break;
          case 191: mask = jj_mask_191; break;
          case 192: mask = jj_mask_192; break;
          case 193: mask = jj_mask_193; break;
          case 194: mask = jj_mask_194; break;
          case 195: mask = jj_mask_195; break;
          case 196: mask = jj_mask_196; break;
          case 197: mask = jj_mask_197; break;
          case 198: mask = jj_mask_198; break;
          case 199: mask = jj_mask_199; break;
          case 200: mask = jj_mask_200; break;
          case 201: mask = jj_mask_201; break;
          case 202: mask = jj_mask_202; break;
          case 203: mask = jj_mask_203; break;
          case 204: mask = jj_mask_204; break;
          case 205: mask = jj_mask_205; break;
          case 206: mask = jj_mask_206; break;
          case 207: mask = jj_mask_207; break;
          case 208: mask = jj_mask_208; break;
          case 209: mask = jj_mask_209; break;
          case 210: mask = jj_mask_210; break;
          case 211: mask = jj_mask_211; break;
          case 212: mask = jj_mask_212; break;
          case 213: mask = jj_mask_213; break;
          case 214: mask = jj_mask_214; break;
          case 215: mask = jj_mask_215; break;
          case 216: mask = jj_mask_216; break;
          case 217: mask = jj_mask_217; break;
        }
        for (int j = 0; j < 117; j++) {
          if (mask[j]) la1tokens[j] = true;
        }
      }
    }
    if (la1tokens[0]) {
      jj_errortokens.addElement(tokenImage[0] + " ");
    }
    for (int i = 1; i < 117; i++) {
      if (la1tokens[i]) {
        jj_errortokens.addElement(tokenImage[i] + " ...");
      }
    }
    jj_endpos = 0;
    jj_maxsize = 1;
    jj_rescan_token();
    jj_add_error_token(0, 0);
    expected_tokens = new String[jj_errortokens.size()];
    for (int i = 0; i < jj_errortokens.size(); i++) {
      expected_tokens[i] = (String)(jj_errortokens.elementAt(i));
    }
    error_line = current.beginLine;
    error_column = current.beginColumn;
    error_string = "";
    Token tok = current;
    for (int i = 0; i < jj_maxsize; i++) {
      if (tok.kind == 0) {
        error_string += " " + tokenImage[0];
        break;
      }
      error_string += " " + tok.image;
      tok = tok.next;
    }
    error_string = error_string.substring(1);
    jj_me.token_error();
  }

  final public void enable_tracing() {
  }

  final public void disable_tracing() {
  }

  private void jj_rescan_token() throws ParseError {
    jj_rescan = true;
    for (int i = 0; i < 33; i++) {
      JJJavaDependCalls p = jj_2_rtns[i];
      do {
        if (p.gen > jj_gen) {
          jj_la = p.arg; jj_lastpos = jj_scanpos = p.first;
          switch (i) {
            case 0: jj_3_1(); break;
            case 1: jj_3_2(); break;
            case 2: jj_3_3(); break;
            case 3: jj_3_4(); break;
            case 4: jj_3_5(); break;
            case 5: jj_3_6(); break;
            case 6: jj_3_7(); break;
            case 7: jj_3_8(); break;
            case 8: jj_3_9(); break;
            case 9: jj_3_10(); break;
            case 10: jj_3_11(); break;
            case 11: jj_3_12(); break;
            case 12: jj_3_13(); break;
            case 13: jj_3_14(); break;
            case 14: jj_3_15(); break;
            case 15: jj_3_16(); break;
            case 16: jj_3_17(); break;
            case 17: jj_3_18(); break;
            case 18: jj_3_19(); break;
            case 19: jj_3_20(); break;
            case 20: jj_3_21(); break;
            case 21: jj_3_22(); break;
            case 22: jj_3_23(); break;
            case 23: jj_3_24(); break;
            case 24: jj_3_25(); break;
            case 25: jj_3_26(); break;
            case 26: jj_3_27(); break;
            case 27: jj_3_28(); break;
            case 28: jj_3_29(); break;
            case 29: jj_3_30(); break;
            case 30: jj_3_31(); break;
            case 31: jj_3_32(); break;
            case 32: jj_3_33(); break;
          }
        }
        p = p.next;
      } while (p != null);
    }
    jj_rescan = false;
  }

  private void jj_save(int index, int xla) {
    JJJavaDependCalls p = jj_2_rtns[index];
    while (p.gen > jj_gen) {
      if (p.next == null) { p = p.next = new JJJavaDependCalls(); break; }
      p = p.next;
    }
    p.gen = jj_gen + xla - jj_la; p.first = token; p.arg = xla;
  }

}

class JJJavaDependCalls {
  int gen;
  Token first;
  int arg;
  JJJavaDependCalls next;
}
